<?php
// $Id: NoAhObject.php,v 1.4 2005/03/22 01:57:22 kerkness Exp $
   
//*************************************************************************//
// This file is part of NoAh.
// 
// NoAh is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// NoAh is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with NoAh; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//*************************************************************************//

/**
 * NoAhObject.php provides methods common to working with most NoAh class objects
 *
 * @author Ryan Mayberry < phparch at gmail dot com >
 * @package noahlib
 */

/**
 * NoAhObject contains basic methods for adding and removing properties from child
 * classes. This class should be extended by the most commonly used NoAh class files
 * and thus provides a consistent way of updating or chaging properties of a class.
 * 
 * @package noahlib
 */
class NoAhObject
{
    /**
     * Class constructor method
     * @return void
     */
    function NoAhObject()
    {
    }

    /**
     * Sets a property name/value pair
     * @param string $name of the property to set
     * @param string $value value to set the property to
     * @return void
     */
    function setAttribute($name,$value)
    {
         $this->$name = $value;
    }

    /**
     * Sets an array of properties
     * @see setAttribute()
     * @param array $attarr array of properties
     * @return void
     */
    function setAttributes( $attarr )
    {
        foreach($attarr as $name=>$value )
        {
            $this->setAttribute($name,$value);
        }
    }

    /**
     * Returns the value of a requested property or false if property not set
     * @see hasAttribute()
     * @param string $name of the property to return
     * @return mixed
     */
    function getAttribute($name)
    {
        return ($this->hasAttribute($name))?$this->$name:false; 
    }
    
    /**
     * Returns true if property has been set and false if not
     * @param string $name of property to look for
     * @return boolean
     */
    function hasAttribute($name)
    {
        return (isset($this->$name))?true:false;
    }

}


?>
