<?php

// $Id: xulform.php,v 1.6 2005/03/22 01:57:22 kerkness Exp $
//*************************************************************************//
// This file is part of NoAh.
// 
// NoAh is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// NoAh is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with NoAh; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//*************************************************************************//

/**
 * Class file for xulform class
 *
 * @author Ryan Mayberry < phparch at gmail dot com >
 * @package xulform
 */

/**
 * Contains methods to build and render XUL forms
 * @package xulform
 */
  class xulform
  {

      var $elements = array();
      var $name;

      function xulform($name='xform')
      {
         $this->name = $name;
      }

      /**
       * Adds a single element
       */
      function addElement( &$ele )
      {
          $this->elements[] = $ele;
      }
      /**
       * Adds an array of elements.
       */
      function addElements( $eles )
      {
          foreach($eles as $k=>$ele ){
              $this->elements[] = $ele;
          }
      }

      /**
       * Loops over all elements and renders them
       */
      function fetchElements()
      {
         $arr = array();
         foreach( $this->elements as $i=>$ele)
         {
            // error_log( $ele->id . ' ' . $ele->label );
             $arr[$ele->id]['body'] = $ele->render();
             $arr[$ele->id]['label'] = $ele->label;
             $arr[$ele->id]['id'] = $ele->id;
         }

         return $arr;
      }


  }
  
?>