<?php

// $Id: xulradiogroup.php,v 1.4 2005/03/22 01:57:22 kerkness Exp $
//*************************************************************************//
// This file is part of NoAh.
// 
// NoAh is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// NoAh is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with NoAh; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//*************************************************************************//

/**
 * Class file for xulradiogroup class
 *
 * @author Ryan Mayberry < phparch at gmail dot com >
 * @package xulform
 */

/**
 * Contains methods to render XUL radiogroup elements
 * @package xulform
 */
 class xulradiogroup extends xulelement
 {
     var $orient;
     /**
      * Class constructor. Sets the id, label and if necessary the
      * value for this xul element
      */
     function xulradiogroup( $id, $label, $value='', $orient='vert' )
     {
         $this->id = $id;
         $this->label = $label;
         $this->value = $value;
         $this->orient = $orient;
     }

     /**
      * Provides as a string the XUL markup to render this element
      */
     function render()
     {
        $this->label = '<label value="'.$this->label.'" control="'.$this->id.'"/>';
        
        $orient = ( $this->orient == 'horz' )? 'hbox' : 'vbox';

        $str = '<radiogroup id="'.$this->id.'" ';
        if ($this->style) {
            $str .= 'style="'.$this->getStyle().'" ';
        }
        if ($this->commands) {
            $str .= $this->getCommandString();
        }
        $str .= '>';
        $str .= '<'.$orient.'>';
        foreach($this->options as $label=>$value)
        {
            $str .= '<radio label="'.$label.'" id="'.$value.'" ';
            if ($this->value == $value ) {
                $str .= 'selected="true" ';
            }
            $str .= '/>';
        }
        $str .= '</'.$orient.'>';
        $str .= '</radiogroup>';

        return $str;
     }
 }
  
?>
