<?php

// $Id: handleRequest.php,v 1.6 2005/03/22 01:55:23 kerkness Exp $

//*************************************************************************//
// This file is part of NoAh.
// 
// NoAh is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// NoAh is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with NoAh; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//*************************************************************************//

/**
 * handleRequest.php is the main 'front loader' for NoAh
 *
 * All requests for specific NoAh pages or Package Commands are initialized
 * and processed with this script.
 *
 * @author Ryan Mayberry < phparch at gmail dot com >
 * @package noah
 */
    // ini_set("display_errors","Off");
    // Include all required NoAh Class files.
    include( CORE_PATH . '/class/noahlib/NoAhObject.php' );
    include( CORE_PATH . '/class/noahlib/NoAhRap.php' );
    include( CORE_PATH . '/class/noahlib/NoAhRequest.php' );
    include( CORE_PATH . '/class/noahlib/NoAhContentSource.php' );
    include( CORE_PATH . '/class/noahlib/NoAhContentPiece.php' );
    include( CORE_PATH . '/class/noahlib/NoAhContentReader.php' );
    include( CORE_PATH . '/class/noahlib/NoAhUser.php' );
    include( CORE_PATH . '/class/noahlib/NoAhLanguage.php' );

    // Include RAP (PHP-RDF) API FILES
    define("RDFAPI_INCLUDE_DIR", CORE_PATH."/class/rdfapi-php/api/");
    include_once(RDFAPI_INCLUDE_DIR . "RdfAPI.php");
   
   /**
    * Set values for mod, pkg and cmd. These make up the main arguments of
    * all NoAh Requests.
    * 
    * mod = Module Name
    * pkg = Package Name
    * cmd = Command to perform
    * 
    * - First see if they are already defined, if so, accept the definition
    * - Check our POST var for values.
    * - Check GET vars for values.
    * - Check SESSION vars for values.
    * - Set default.
    */
    $mod = ''; $pkg = ''; $cmd = '';

    // Set the selected module for this request.
    if ( isset($_SESSION['mod']) )     $mod = $_SESSION['mod'];
    if ( isset($_GET['mod']) )         $mod = $_GET['mod'];
    if ( isset($_POST['mod']) )        $mod = $_POST['mod'];
    if ( defined('MOD') )              $mod = MOD;
    
    // Set the selected package for this request.
    if ( isset($_SESSION['pkg']) )     $pkg = $_SESSION['pkg'];
    if ( isset($_GET['pkg']) )         $pkg = $_GET['pkg'];
    if ( isset($_POST['pkg']) )        $pkg = $_POST['pkg'];
    if ( defined('PKG') )              $pkg = PKG;

    // Set the selected command for this request.
    if ( isset($_SESSION['cmd']) )     $cmd = $_SESSION['cmd'];
    if ( isset($_GET['cmd']) )         $cmd = $_GET['cmd'];
    if ( isset($_POST['cmd']) )        $cmd = $_POST['cmd'];
    if ( defined('CMD') )              $cmd = CMD;

    // If all we have so far is a command name, try and determine
    // module and package automatically
    if ( $cmd && ! $mod && ! $pkg ) {
        require_once(CORE_PATH.'/class/noahlib/NoAhContentList.php');
        $plist = new NoAhContentList('noah_pages');
        foreach( $plist->getListValues() as $li=>$item ){
          $parr = explode('/',$item['value']);
          if ( strtolower($parr[2]) == strtolower($cmd) ) {
              $mod = $parr[0];
              $pkg = $parr[1];
          }
        }
    }

    // If nothing found yet, set default values for each.
    if ( ! $mod )                      $mod = 'nosystem';
    if ( ! $pkg )                      $pkg = 'general';
    if ( ! $cmd )                      $cmd = 'loadSystemAdmin';

    /**
     * @global  MOD_NAME      name of the module we are loading
     * @global  PKG_NAME      name of the package we are loading
     * @global  MOD_PATH      path to module files that we are loading
     */
    define('MOD_NAME',$mod );
    define('PKG_NAME',$pkg );
    define('MOD_PATH',CORE_PATH.'/modules/'.MOD_NAME);

    // Create an instance of NoAhUser
    // MOVED TO NoAhRequestHandler class
    //$noUser =& new NoAhUser();
    //$noLang =& new NoAhLanguage();

    $requestHandler = new NoAhRequestHandler( $mod, $pkg, $cmd );
    $requestHandler->processRequests();
    $requestHandler->processResults(); 
    
    // Create a instance of NoAhRequest.
    // providing mod, pkg, cmd as request arguments 

  
?>
