<?php

// Build some Tabs for this page
include_once(CORE_PATH.'/class/common/tabs.php');
$tabs = new XoopsTabs();
$link = 'events.php';
$tabs->addTab( 'eventhome', $link, 'View Web Page', $weight=9 );
$link = 'events.php?op=eventadmin';
$tabs->addTab( 'eventadmin', $link, 'Show All Event', $weight=10 );
$link = 'events.php?op=eventform';
$tabs->addTab( 'eventform', $link, 'Add Event', $weight=12 );
$tabs->setCurrent('eventadmin');
$noAh->addContent('tabs',$tabs->render());

// This page should display a list of events 
// and allow the user to select a single event for editing.

// Create NoAh Content Reader
$myEvents = new NoAhContentReader('events');
$myImages = new NoAhContentReader('event_images');

// Order content by end_date then start_date decending
$myEvents->setSort('end_date, start_date', 'DESC');
$total_events = $myEvents->countContent();
$myEvents->setLimit($total_events);
$events = $myEvents->getContent();

$total_images = $myImages->countContent();

// Loop over each Event and suppliment details with
// image info.
foreach( $events as $i=>$event ){

    $myImages->addFilter('eventid','=',$event['eventid']);
    $events[$i]['img_count'] = $myImages->countContent();
    $myImages->clearFilter();

}

// Add event and image details to our page template
$noAh->addContent('events',$events);
$noAh->addContent('total_events',$total_events);
$noAh->addContent('total_images',$total_images);

?>
