<?php

  //
  $page = $noAh->getCmdProp( $noAh->cmd );
  
  // declare variables
  $events = array();
  $images = array();
  $onnow = array();
  $onnext = array();
  $events['content'] = array();
  $show_img = false;
  $show_img_link = false;

  // Get a Content Reader object for events and
  // set common properties for fetching content
  $myImages = new NoAhContentReader('event_images');
  $myImages->setLimit(100);
  $myEvents = new NoAhContentReader('events');
  $myEvents->setLimit(100);
  $myEvents->setSort('start_date', 'DESC');

  // swithc over the current CMD and build filters 
  // for our query.
  switch( strtolower(CMD) ){
  case 'comingevents';
      $myEvents->addFilter('start_date','>', time() );
      $events['content'] = $myEvents->getContent();
      $show_img = ( isset($_GET['id']) && $_GET['id'] )? true : false;
      break;
  case 'pastevents';
      if ( isset($_GET['id']) && $_GET['id'] ) {
       $myEvents->addFilter('eventid','=', $_GET['id']);
       $myEvents->setLimit(1);
       $events['content'] = $myEvents->getContent();
       $show_img = true;
      }else{
       $myEvents->addFilter('end_date','<', time() );
       $events['content'] = $myEvents->getContent();
       $show_img = false;
      }
      break;
  case 'currentevents';
      // See if there are any events, on now
      $mytime = time();
      $fstr = " WHERE ( start_date <= $mytime && end_date >= $mytime ) ";
      $myEvents->addFilterString($fstr);
      $onnow = $myEvents->getContent();
      if ( $onnow ) {
          $nowid = $onnow[0]['eventid'];
      } else {
          $nowid = 0;
      }
      $myEvents->clearFilter();

      // Get the Next Event
      $myEvents->addFilter('start_date','>', time() );
      $onnext = $myEvents->getContent();
      if ( $onnext ) {
          $nextid = $onnow[0]['eventid'];
      } else {
          $nextid = 0;
      }
      $myEvents->clearFilter();

      // Get most recent Event
      if ( $nowid ) {
          $fstr = " WHERE ( end_date < $mytime && eventid != $nowid ) ";
      } else {
          $fstr = " WHERE ( end_date < $mytime ) ";
      }
      $myEvents->addFilterString($fstr);
      $myEvents->setLimit(1);
      $events['content'] = $myEvents->getContent();
      $show_img = true;
      break;
  }

  //print $myEvents->getSql();

  foreach($events['content'] as $i=>$event){
    if ( $event['start_date'] == $event['end_date'] ) {
        $events['content'][$i]['date'] = date('F j, Y',$event['start_date']);
    } else {
        $events['content'][$i]['date'] = date('F j',$event['start_date']).' - '.date('F j, Y',$event['end_date']);
    }

    // Loop over each event and check to see if there are any 
    // images present
    $myImages->clearFilter();
    $myImages->addFilter('eventid','=',$event['eventid']);
    $count = $myImages->countContent();
    if ( $count && ! $show_img ) {
        $events['content'][$i]['show_img_link'] = 1;
    } else {
        $events['content'][$i]['show_img_link'] = 0;
    }
    $myImages->clearFilter();

  }

  // Check for images in $onnow event
  if ( $onnow ) {
      $myImages->clearFilter();
      $myImages->addFilter('eventid','=',$onnow[0]['eventid']);
      $count = $myImages->countContent();
      if ( $count ) {
          $onnow[0]['show_img_link'] = 1;
      } else {
          $onnow[0]['show_img_link'] = 0;
      }
      $myImages->clearFilter();
  }
  // Check for images in $onnow event
  if ( $onnext ) {
      $myImages->clearFilter();
      $myImages->addFilter('eventid','=',$onnext[0]['eventid']);
      $count = $myImages->countContent();
      if ( $count ) {
          $onnext[0]['show_img_link'] = 1;
      } else {
          $onnext[0]['show_img_link'] = 0;
      }
      $myImages->clearFilter();
  }

  // If $onnow event details are present convert these details for display
  if ( $onnow && $onnow[0]['start_date'] == $onnow[0]['end_date'] ) {
      $onnow[0]['date'] = date('F j, Y',$onnow[0]['start_date']);
  } else if ( $onnow ) {
      $onnow[0]['date'] = date('F j',$onnow[0]['start_date']).' - '.date('F j, Y',$onnow[0]['end_date']);
  }
  if ( isset($onnow[0]) ) {
      $onnow = $onnow[0];
  }
  // If $onnow event details are present convert these details for display
  if ( $onnext && $onnext[0]['start_date'] == $onnext[0]['end_date'] ) {
      $onnext[0]['date'] = date('F j, Y',$onnext[0]['start_date']);
  } else if ( $onnext ) {
      $onnext[0]['date'] = date('F j',$onnext[0]['start_date']).' - '.date('F j, Y',$onnext[0]['end_date']);
  }
  if ( isset($onnext[0]) ) {
      $onnext = $onnext[0];
  }



  if ( $show_img && $events['content'] ) {
      $myImages->setSort('weight', 'ASC');
      $eventid = $events['content'][0]['eventid'];
      $myImages->addFilter('eventid','=',$eventid);
      $images = $myImages->getContent();
  }


  $noAh->addContent('events',$events);
  $noAh->addContent('images',$images);
  $noAh->addContent('onnow',$onnow);
  $noAh->addContent('onnext',$onnext);
  $noAh->addContent('show_img',$show_img);
  $noAh->addContent('show_img_link',$show_img_link);
  $noAh->addContent('page', $page );

?>
