<?php
// $Id: dbwizard.php,v 1.4 2005/03/09 04:44:35 kerkness Exp $

    require_once( CORE_PATH.'/class/db/dbloader.php' );
    
	class NoAhDbWizard extends NoAhDatabase
	{

        var $db;
        var $tables;
        var $source;
        var $pieces;

	   /**
		* class constructor for NoAhDbWizard
		* NoAhTableConsume contains all functions associated with
		* creating a new NoAhGroup from an existing db table
		*/
		function NoAhDbWizard()
		{
		}

        function loadMemSource()
        {
            if ( ! $_SESSION['mem']['dsource'] ) {
               $this->source = array();
               $this->pieces = array();
            } else {
            $this->source = $_SESSION['mem']['dsource'];
            $this->pieces = $_SESSION['mem']['dpieces'];
            }
        }

		function createTable( $table, $key )
		{
			$prime = $key;
			$table_name = $this->prefix($table);
			$sql = "CREATE TABLE $table_name (
				$prime INT NOT NULL AUTO_INCREMENT ,
				UNIQUE ( $prime )
				)";
			if( ! $res = $this->query($sql) ){
				error_log( $this->error()."Failed creating table : $sql" );
                return ( $this->error() );
            }

		return 1;
		}

        function addToContent($field,$label,$input,$order)
        {
            $this->loadMemSource();
            foreach($this->pieces as $k=>$v )
            {
                if ( isset($v['name']) && $v['name'] == $field ) {
                  $this->pieces[$k]['added'] = 1;
                  $this->pieces[$k]['label'] = $label;
                  $this->pieces[$k]['input'] = $input;
                  $this->pieces[$k]['order'] = $order;
                }
            }
            $this->updateMemSource();
            return true;
        }

        function removeFromContent($field)
        {
            $this->loadMemSource();
            foreach($this->pieces as $k=>$v )
            {
                if ( isset($v['name']) && $v['name'] == $field ) {
                   $this->pieces[$k]['added'] = 0;
                }
            }
            $this->updateMemSource();
            return true;
        }

        function changeAttributeValue( $field, $attr, $value )
        {
            $this->loadMemSource();
            foreach($this->pieces as $k=>$v )
            {
                if ( isset($v['name']) && $v['name'] == $field ) {
                   $this->pieces[$k][$attr] = $value;
                }
            }
            $this->updateMemSource();
            return true;
        }

        function updateMemSource()
        { 
            $_SESSION['mem']['dsource'] = $this->source;
            $_SESSION['mem']['dsource']['dbconn'] = $this->conn_name;
            $_SESSION['mem']['dpieces'] = $this->pieces;
        }

		function dropTable( $table )
		{
			$table_name = $this->prefix($table);
			$sql = "DROP TABLE $table_name";
			if( ! $res = $this->query($sql) ){
				error_log( $this->error()."Failed to drop table : $sql" );
                return ( $this->error() );
            }
		return 1;
		}

        function addField( $table, $name, $type='varchar', $len=50, $null=1, $default=''){
			$table_name = $this->prefix($table);

            $type = str_replace('String','VARCHAR',$type);
            $type = str_replace('Int','INT',$type);
            if ( ! $len) {
                $len = 50;
            }
            $typestr = ( $type=='Text' )? 'TEXT' : "$type($len)";
            $defaultstr = ( $default == "Null" )? '' : "DEFAULT '$default'";
            $nullstr = ( $null )? '' : 'NOT NULL';

			$sql = "ALTER TABLE $table_name 
                ADD $name $typestr $defaultstr $nullstr";
			if( ! $res = $this->query($sql) ){
				error_log( $this->error()." Failed to add field : $sql" );
                return ( $this->error() );
            }
		return 1;
        }
		function dropField( $table, $field )
		{
            error_log("Attempting to delete $table, $field");
            // Make sure it isn't our primary field
            if ( $this->getTablePrimary($table)==$field) {
                return "Cannot delete primary key.";
            }
			$table_name = $this->prefix($table);
			$sql = "ALTER TABLE $table_name DROP $field";
			if( ! $res = $this->query($sql) ){
				error_log( $this->error()."Failed to drop field : $sql" );
                return ( $this->error()."Failed to drop field : $sql" );
            }
		return 1;
		}


        /**
        * @results	all tables in the database
        * @param	string	$table name of a table
        * @return	array
        */
        function listFields( $table )
        { 
        $fields = mysql_list_fields($this->database, $this->prefix($table), $this->conn );
        $columns = mysql_num_fields($fields);
        
        	for ($i = 0; $i < $columns; $i++) {
          	 	$results[$i] = mysql_field_name($fields, $i);
        		// print $results[$i];
        	}
         
         return $results;
        }
        
        function tableInfo($table){
        	$result = mysql_query ("SELECT * FROM $table", $this->conn);
        	$info['fields'] = mysql_num_fields ($result);
        	$info['rows']   = mysql_num_rows ($result);
           return $info;
        }
        
        /**
        * @param	string	$table name of a table
        * @param	string	$field name of a field
        */
        function getFieldType( $table )
        {
        	$result = mysql_query ("SELECT * FROM $table", $this->conn);
        	$fields = mysql_num_fields ($result);
        	$rows   = mysql_num_rows ($result);
        
        	$i = 0;
            $f = array();
        	$table = mysql_field_table ($result, $i);
        
        	//error_log "Your '".$table."' table has ".$fields." fields and ".$rows." records <BR>";
        	//error_log "The table has the following fields <BR>"; 
        	while ($i < $fields) {
            $f[$i]['name'] = mysql_field_name  ($result, $i);
            $f[$i]['type']  = mysql_field_type  ($result, $i);
            $f[$i]['length']   = mysql_field_len   ($result, $i);
            $f[$i]['flags'] = mysql_field_flags ($result, $i);
            //error_log $type." ".$name." ".$len." ".$flags."<BR>";
            $i++;
        	}
        return $f;
        }
        
        // this function check the database for existing fields
        // so that we don't try and create duplicates.
        function checkForFields( $field, $table )
        {
        
        	$table_fields = listFields( $table );
        	
        	foreach ( $table_fields as $k=>$v )
        	{
        		if ( $field == $v )
        		{
        			$field_found = true;
        			return true;
        		}
        	}
        return false;
        }
        
        // this function looks in the database to make sure the
        // table that the person is trying to add doesn't already
        // exsist. If the table does exist return 1 if not return 0
        function checkForTable( $table )
        {
        	$table_list = listTables();
        	foreach ( $table_list as $k=>$v )
        	{
        		$v = str_replace(XOOPS_DB_PREFIX.'_', '', $v);
        	
        		if( $v == $table )
        		{
        			$match_found = true;
        		}
        	}
        	if ( $match_found )
        	{
        		$result = 1;
        	}
        		else
        	{
        		$result = 0;
        	}
        	
        return $result;	
        }

        function getTablePrimary ($table)
        {
            $query = "DESC ".$this->prefix($table);
            $results = $this->query($query);
        
            while ($row = $this->fetchArray($results))
            {
            	if ($row['Type']="PRI")
               {
            		// print "I found the primary key! <br>";
            		$prime = $row['Field'];
            		// print $row[Field];
            		/* drop out , as we've found the key */ 
            		break;  
               }
            }
            return $prime;
        }
		
}
?>