<?php
// $Id: dbwizard_index.php,v 1.4 2005/03/22 02:01:19 kerkness Exp $
  
  
  // This page fires every time the dbwizard package is called.
  
  // It will load an instance of the DBWizard Class
  // And control access to methods called from commands.
  require_once( 'class/dbwizard.php' );
  require_once( CORE_PATH.'/class/noahlib/NoAhRap.php' );

  // Use this constant as a flag for using the dsource _session var
  // of concern in the save_source.php script and process
  // Ensures that scripts which look for a source and pieces session
  // info, grab the right one.
  define('USE_DB_SOURCE_SESS',true);
  
  // HACK ALERT: I need to strip any database field we are keeping track
  // of in our dsource _SESSION var. But only if we are saving our source 
  // file. This is a required step, but this file or this specific location
  // might not be the most optimal choice. but at the moment it will 
  // have to do.
  if ( isset($_POST['cmd']) && $_POST['cmd'] == 'saveSourceXML' ){
    foreach ($_SESSION['mem']['dpieces'] as $i=>$piece ){
       if ( isset($piece['added']) && $piece['added']==1 ) continue;
       unset($_SESSION['mem']['dpieces'][$i]);
       error_log('REMOVING $i');
    }
  }
  
  // Get a list of database connections. These connections are defined in
  // noah_conf.php
  foreach( $_REQUEST['noah_conn'] as $i=>$conn_info)
  {
     $connections[] = $conn_info['name'];
  }
  if ( isset($_SESSION['temp_conn']) ) {
     $connections[] = $_SESSION['temp_conn']['name'];
  }


  // Check out _GET variable for any request to load a specific connection
  if ( isset($_GET['use_conn']) && $_GET['use_conn'] ) {
      error_log("*********************** getting conn {$_GET['use_conn']}");
      // change (or set) the name of the connection as current
      $_SESSION['use_conn'] = $_GET['use_conn'];
  }

  // Create our db wizard class object
  $dbwiz = new NoAhDbWizard();
  $dbwiz->openConnection();

  // If there is a current 'source' and 'fields' in the memory
  // Load these arrays into our class object.
  if ( isset($_SESSION['mem']['dsource']) && $_SESSION['mem']['dsource']) {
     $dbwiz->loadMemSource();
  }


  // Handle Command Functions
  if ( $noAh->hasFunc() ) {
      $functions = $noAh->getFunc();
      for($i=0;$i<count($functions);$i++){
          switch($functions[$i]){
          case 'addToContent':
              $results = $dbwiz->addToContent($_POST['field'],$_POST['label'],$_POST['input'],$_POST['order']);
          break;
          case 'removeFromContent':
              $results = $dbwiz->removeFromContent($_POST['field']);
          break;
          case 'changeAttributeValue':
              $results = $dbwiz->changeAttributeValue($_POST['field'],$_POST['attr'],$_POST['value']);
          break;
          case 'createTable':
              $table = $_POST['table'];
              $key = str_replace('Key: ','',$_POST['key']);
              $res = $dbwiz->createTable($table, $key);
              if ( $res == 1 ) {
                  $results = "Success";
                  // Set our Session Memmory 'load_table' value to
                  // the new table name.
                  $_SESSION['mem']['load_table'] = $table;
              }else{
                  $results = $res;
              }
          break;
          case 'dropTable':
              $table = $_POST['table'];
              $res = $dbwiz->dropTable($table);
              if ( $res == 1 ) {
                  $results = "Success";
                  // Set our Session Memmory of load table to empty
                  // if we just dropped that table.
                  if ( $_SESSION['mem']['load_table'] == $table )
                     $_SESSION['mem']['load_table'] = '';
              }else{
                  $results = $res;
              }
          break;
          case 'addField':
              $ftable = $_POST['ftable'];
              $fname = $_POST['fname'];
              $ftype = $_POST['ftype'];
              $flen = $_POST['flen'];
              $fnull = $_POST['fnull'];
              $fdefault = str_replace('Default: ','',$_POST['fdefault']);
              $res = $dbwiz->addField($ftable,$fname,$ftype,$flen,$fnull,$fdefault);
              if ( $res == 1 ) {
                  $results = "Success";
                  // Set our Session Memmory of load table to empty
                  // if we just dropped that table.
                  $_SESSION['mem']['load_table'] = $ftable;
              }else{
                  $results = $res;
              }
          break;
          case 'dropField':
              $table = $_SESSION['mem']['load_table'];
              $field = $_POST['field'];
              $res = $dbwiz->dropField($table, $field);
              if ( $res == 1 ) {
                  $results = "Success";
              }else{
                  $results = "Err:".$res;
              }
          break;
          case 'testConnection':
              $host = str_replace('Host: ','',$_POST['host']);
              $user = $_POST['user'];
              $pass = $_POST['pass'];
              $database = $_POST['db'];
              $res = $dbwiz->testConnection( trim($host), $user, $pass, $database );
              if ( $res == 1 ) {
                  $results = 'Success';    
              } else {
                  $results = $res;    
              }
              break;
          case 'updateConnection':
              $db = array();
              $db['host'] = str_replace('Host: ','',$_POST['host']);
              $db['name'] = str_replace('Name: ','',$_POST['conn_name']);
              $db['user'] = $_POST['user'];
              $db['pass'] = $_POST['pass'];
              $db['database'] = $_POST['db'];
              $res = $dbwiz->testConnection(trim($db['host']), $db['user'], $db['pass'], $db['database']);
              if ($res==1) {
                  $_SESSION['temp_conn'] = $db;
                  $results = 'Connection Settings Saved';
              }else{
                  $results = "Bad connection settings.  \nConnection DID NOT save.";    
              }
              break;

          }

          if ( $results ) {
              $noAh->addContent('results',$results);
          }

      }
  }



?>
