<!--// START ADD/DROP TABLE FUNCTIONS //-->
function createTable(){
    var table = document.getElementById('new_table');
    var key = document.getElementById('new_table_key');
    var err = '';
    if ( table.value == '' || table.value == 'Enter table name') {
        err += 'Please enter a table name'
    }
    if ( key.value == '' ) {
        err += 'Please enter a table name'
    }
    if ( err ) {
        alert( err );
        return false;
    }
    url   = siteURL()+"/request.php";
    // set the command 
    cmd = "createTable";
    // build query string for the request.
    query = "pkg=dbwizard&cmd="+cmd+"&table="+table.value+"&key="+key.value;
    // Call forum post function
    formPost(url,query,createTableResults);
}
function createTableResults( response ){
    if ( response != 'Success' ) {
        alert( response );
        return false;
    }
    var table = document.getElementById('new_table');
    var key = document.getElementById('new_table_key');

    // Add table name to select table menu.
    appendToList('sel_table',table.value);    
    appendToList('drop_table',table.value);    
    appendToList('add_to_table',table.value);    

    // reset createTable form.
    table.value = 'Enter table name';
    key.value = 'Key: fieldid';
    
    // Load new table in table_frame.
    loadTableInfo();
}
function dropTable(){
    var table = document.getElementById('drop_table');
    var selectedTable = table.selectedItem.label;
    if ( selectedTable == '-' ) {
        alert("Please select a table");
        return false;
    }
    
    url   = siteURL()+"/request.php";
    res = confirm("Are you SURE you want to drop '"+selectedTable+"'?\nALL data will be lost.");
    if ( res ) {
        // set the command 
        cmd = "dropTable";
        // build query string for the request.
        query = "pkg=dbwizard&cmd="+cmd+"&table="+selectedTable;
        // Call forum post function
        formPost(url,query,dropTableResults);
    }else{
        return false;
    }
}
function dropTableResults( response ){
    if ( response != 'Success' ) {
        alert( response );
        return false;
    }
    var table = document.getElementById('drop_table');
    var selectedTable = table.selectedItem.label;

    // Add table name to select table menu.
    removeFromList('sel_table',selectedTable);    
    removeFromList('drop_table',selectedTable);
    removeFromList('add_to_table',selectedTable);

    document.getElementById('sel_table').selectedIndex = 0;
    document.getElementById('add_to_table').selectedIndex = 0;
    table.selectedIndex = 0;

    // Load new table in table_frame.
    loadTableInfo();
}

<!--// END ADD TABLE / ADD FIELD FUNCTIONS //-->

<!--// START LOAD TABLE INFO FUNCTIONS //-->
function loadTable(){
    
    var tree = document.getElementById('table_tree');
    var table =tree.view.getCellText(tree.currentIndex,"table");

    if ( ! table ) {
        alert("Please select a table.");
        return false;
    }
    tellServer( 'load_table', table, loadTableInfo );
}

function loadTableInfo(response){
   // alert(response);
   var cmd = 'loadTable';
   var mod = 'nosystem';
   var pkg = 'dbwizard';
   var query = 'cmd='+cmd+'&mod='+mod+'&pkg='+pkg;
   var tframe = document.getElementById('table_frame');
   tframe.setAttribute('src', '');
   tframe.setAttribute('src', siteURL()+'/request.php?'+query);

}
<!--// END LOAD TABLE INFO FUNCTIONS //-->

<!--// START CONNECTION FUNCTIONS //-->
function testConnection(){
    url   = siteURL()+"/request.php";
    // set the command 
    cmd = "testConnection";
    // build query string for the request.
    query = "pkg=dbwizard&cmd="+cmd+"&name=" + name + connString();
    // Call forum post function
    formPost(url,query,showResults);
}               
function updateConnection(){

    var res = confirm ("These connection settings will only be saved for this session. If you want to permantenly add this connection to NoAh you have to update your noah_conf.php file. Proceed ?")

    if ( ! res ) {
        return false;
    }
    url   = siteURL()+"/request.php";
    // set the command 
    cmd = "updateConnection";
    // build query string for the request.
    query = "pkg=dbwizard&cmd="+cmd+"&name=" + name + connString();
    // Call forum post function
    formPost(url,query,showResults);
}
function changeConnection(){
    var selconn = document.getElementById('change_connection');
    if ( ! selconn.selectedIndex ) {
        alert('Please choose a connection');
        return;
    }
    reloadDbWizard( selconn.value );
}
// Reloads the database wizard page. accepting a new
// connection name to use.
function reloadDbWizard( conn ){
    var par = parent.window;
    par.loadDbWizView( '', conn );
}

function connString(){
    var conn_name = document.getElementById('conn_name').value;
    var dbhost = document.getElementById('dbhost').value;
    var dbuser = document.getElementById('dbuser').value;
    var dbpass = document.getElementById('dbpass').value;
    var dbname = document.getElementById('dbname').value;
    var query = '&host='+dbhost+'&user='+dbuser+'&pass='+dbpass+'&db='+dbname+'&conn_name='+conn_name;
  return query;
}
<!--// END CONNECTION FUNCTIONS //-->


<!--// START ADD FIELD FUNCTIONS //-->

function addField(){
    var seltable = document.getElementById('add_to_table');
    var ftable = seltable.selectedItem.label;
    var fname = document.getElementById('add_field_name').value;
    var seltype = document.getElementById('add_field_type');
    var ftype = seltype.selectedItem.label;
    var flen = document.getElementById('add_field_len').value;
    var fnull = document.getElementById('add_field_null').checked;
    var fdefault = document.getElementById('add_field_default').value;

    // Validate all values
    err = '';
    if ( seltable.selectedIndex == 0 ) {
        err += 'Please select a table \n';
    }
    if ( fname == 'Field Name' ) {
        err += 'Please provide a name for your field \n';
    }
    if ( seltype.selectedIndex == 0 ) {
        err += 'Please select a field type \n';
    }
    if ( err ) {
        alert(err);
        return false;
    }
    url   = siteURL()+"/request.php";
    // set the command 
    cmd = "addField";

    //
    fstr = "&ftable="+ftable+"&fname="+fname+"&ftype="+ftype+"&flen="+flen+"&fnull="+fnull+"&fdefault="+fdefault;
    // build query string for the request.
    query = "pkg=dbwizard&cmd="+cmd+fstr;
    // Call forum post function
    formPost(url,query,showNewField);

}
function showNewField(response){
    if ( response != 'Success' ) {
        alert( response );
        return false;
    }

    // reset form
    var fname = document.getElementById('add_field_name');
    var seltype = document.getElementById('add_field_type');
    var flen = document.getElementById('add_field_len');
    var fnull = document.getElementById('add_field_null');
    var fdefault = document.getElementById('add_field_default');

    fname.value = "Field Name";
    seltype.selectedIndex = 0;
    fnull.checked = true;
    flen.value = 50;
    fdefault.value = "Default: Null";
    loadTableInfo(response);
}


<!--// END ADD FIELD FUNCTIONS //-->

<!--// GENERIC FIELD FUNCTIONS //-->
function textFocus( id, def ){
    var ele = document.getElementById(id);
    if ( ele.value == def ) {
        ele.value = '';
    }
}
function textUnFocus( id, def ){
    var ele = document.getElementById(id);
    if ( ele.value == '' ) {
        ele.value = def;
    }
}


<!--// TABLE FIELD ACTIONS FUNCTIONS //-->
function submitFieldAction(){
    var selfield = document.getElementById('action_field_name');
    var field = selfield.selectedItem.label;
    var selaction = document.getElementById('action_name');
    var action = selaction.selectedItem.label;
    if ( selaction.selectedIndex == 0 || selfield.selectedIndex == 0) {
        alert("Please select a field and action.");
        return false;
    }
    if ( action == 'Drop' ) {
        actionDrop(field);
    }
}
function actionDrop( field ){
  url   = siteURL()+"/request.php";
  res = confirm("Are you SURE you want to drop '"+field+"'?\nALL data will be lost.");
  if ( res ) {
      // set the command 
      cmd = "dropField";
      // build query string for the request.
      query = "pkg=dbwizard&cmd="+cmd+"&field="+field;
      // Call forum post function
      formPost(url,query,dropFieldResults);
  }else{
      return false;
  }
}
function dropFieldResults(response){
    if ( response != 'Success' ) {
        alert( response );
        return false;
    }
    var cmd = 'loadTable';
    var mod = 'nosystem';
    var pkg = 'dbwizard';
    var query = 'cmd='+cmd+'&mod='+mod+'&pkg='+pkg;
    document.location = siteURL()+'/request.php?'+query;
}


<!--// END TABLE FIELD ACTIONS FUNCTIONS //-->

function saveSourceXML()
{
    var filename = document.getElementById('content_source').value;
    url   = siteURL()+"/request.php";
    fstr = "&file="+filename;
    query = "pkg=dbwizard&cmd=saveSourceXML"+fstr;
    formPost(url,query,handleSaveXMLResults);
}
function handleSaveXMLResults(response)
{
    alert(response);
    
    // Reload this page
    var table = document.getElementById('table_name').value;
    var mypa = window.parent;
    var main = mypa.parent;

    main.loadDbWizView( table );
    
}


<!--// FIELD / CONTENT SOURCE FUNCTIONS //-->

function fieldInclude(field){
    var chbox = document.getElementById('finclude_'+field);
    var cmd = '';
    // If box is checked, activate row.
    if ( chbox.checked ) {
        disableFieldRow(field, false);
        cmd = "addToContent";
    } else {
        disableFieldRow(field, true);
        cmd = "removeFromContent";
    }

    // get the other details about our field
    var label = document.getElementById('flabel_'+field).value;
    var order = document.getElementById('flabel_'+field).value;
    var selinput = document.getElementById('finput_'+field);
    var input = selinput.selectedItem.label;
    
    // Enable our save button
    disableSaveButton( false );
    
    url   = siteURL()+"/request.php";
    fstr = "&field="+field+"&label="+label+"&input="+input+"&order="+order;
    query = "pkg=dbwizard&cmd="+cmd+fstr;
    formPost(url,query,doNothing);
}
function disableFieldRow( field, disable ){
    var flabel = document.getElementById('flabel_'+field);
    var finput = document.getElementById('finput_'+field);
    var forder = document.getElementById('forder_'+field);
    flabel.disabled = disable;
    finput.disabled = disable;
    forder.disabled = disable;
    // Enable our save button
    disableSaveButton( false );
    
}

function fieldLabel(field){
    var label = document.getElementById('flabel_'+field).value;
    changeAttributeValue(field, 'label', label);
}

function fieldInput(field){
    var selinput = document.getElementById('finput_'+field);
    var input = selinput.selectedItem.value;
    //alert(input);
    changeAttributeValue(field, 'input', input);
}

function fieldOrder(field){
    var order = document.getElementById('forder_'+field).value;
    changeAttributeValue(field, 'order', order);
}

function changeAttributeValue(field, attr, value){
    // Enable our save button
    disableSaveButton( false );
    url   = siteURL()+"/request.php";
    fstr = "&field="+field+"&attr="+attr+"&value="+value;
    query = "pkg=dbwizard&cmd=changeAttributeValue"+fstr;
    formPost(url,query,doNothing);
}

function disableSaveButton( onoff ){
   var savebut = document.getElementById('save_source_button');
   savebut.setAttribute('disabled', onoff );
}

// this function fetches details about field from
// hidden labels and populates form in parent window.
function createFieldFromSource( name ){

    // get the field details
    var table = document.getElementById('table_name').value;
    var field = document.getElementById('mrow_'+name+'_name');
    var type = document.getElementById('mrow_'+name+'_type');
    var length = document.getElementById('mrow_'+name+'_length');
    var defvalue = document.getElementById('mrow_'+name+'_default');

    // get the form field elements
    var tabs = window.parent.document.getElementById('table_tabs');
    var tabs = window.parent.document.getElementById('table_tabs');
    var ftable = window.parent.document.getElementById('add_to_table');
    var fname = window.parent.document.getElementById('add_field_name');
    var ftype = window.parent.document.getElementById('add_field_type');
    var flength = window.parent.document.getElementById('add_field_len');
    var fdefault = window.parent.document.getElementById('add_field_default');

    // update values.
    tabs.selectedIndex = 1;
    if ( table ){ 
    citems = ftable.firstChild.childNodes;
        for (var i=0;i<citems.length; i++ ) {
          if ( citems[i].label==table) {
              ftable.selectedItem = citems[i];
          }
        }
    }
    if ( field && field.value ) fname.value = field.value;
    ftype.selectedIndex = 1; // NOTE: DEFAULTING TO STRING  
    if ( length && length.value ) flength.value = length.value;
    if ( defvalue && defvalue.value ) fdefault.value = defvalue.value;

    //alert(table + field + type + length + defvalue );
}

function switchToSourceManager( name )
{
    var mypa = window.parent;
    var main = mypa.parent;

   main.loadContentSourceView( name );

//    url   = siteURL()+"/request.php";
//    fstr = "&source="+name;
//    query = "?pkg=contentsources&cmd=ContentSourcesLoader"+fstr;
    //mypa.location = url+query;
//    alert(mypa.parent.location);
}
<!--// FIELD / CONTENT SOURCE FUNCTIONS //-->
