  
  function loadSourceDetails( name, new_piece )
  {
      // First close any source that is already open
      closeSource();
      var tree = document.getElementById('source_tree');
      if ( ! name ) {
          name=tree.view.getCellText(tree.currentIndex,"value");
      }

      // Close side menu select source.
      // Open side menu edit source.
      var currs = document.getElementById('current_source');
      var selbox = document.getElementById('find_source_view');
      var editbox = document.getElementById('edit_source_view');
      // selbox.style.display = 'none';
      editbox.style.display = '';
      currs.value = name;
      
      var iframe = document.getElementById('iframe_content_details');
      var query = 'mod=nosystem&pkg=contentsources&cmd=ContentDetailsLoader&source='+name;
      if ( new_piece ){
        query = query+'&new_piece='+new_piece;
      }
      iframe.setAttribute('src',siteURL()+'/request.php?'+ query);
      
  }
  
  function closeSource()
  {
      // Close side menu select source.
      // Open side menu edit source.
      var selbox = document.getElementById('find_source_view');
      var editbox = document.getElementById('edit_source_view');
     // Get our Save Button.
      var savebut = document.getElementById('save_source_button');
      var currs = document.getElementById('current_source');
      currs.value = '';
     
     // If savebutton is not active, then no changes have been
     // made to the source. If it is active, alert the user that
     // changes have been made and give the option to close or
     // cancel command.
     if ( savebut.getAttribute('disabled')=='false' ) { 
       var doclose = confirm("You have not saved your changes. Are you sure you want to close source?");
       if ( ! doclose ){
          return;
       }
      }
      
     // selbox.style.display = '';
     editbox.style.display = 'none';
     savebut.setAttribute("disabled", true);

      var iframe = document.getElementById('iframe_content_details');
      iframe.setAttribute('src','');

     // Kill the session memory on the server
    // set the URL of the script we will post to.
    url   = siteURL()+"/request.php";

    // set the command 
    cmd = "killSessionMemory";

    // build query string for the request.
    query = "mod=nosystem&pkg=contentsources&cmd="+cmd
    // Call forum post function
    formPost(url,query,doNothing);
  }

  function showPieceForm(name) 
  {
      var ison = document.getElementById( 'form_ison' );
      var curr = document.getElementById( 'form_'+ison.value );
      var rows = document.getElementById( 'form_'+name );
      var jbox = document.getElementById( 'joins_'+name );
      var jcurr = document.getElementById( 'joins_'+ison.value );      
      curr.style.display = 'none';
      rows.style.display = '';
      jcurr.style.display = 'none';
      jbox.style.display = '';
      ison.value = name;
      
  }
  
function changeElement( id, ftype )
{    
    // Grab user name and password from form fields.
    var item = document.getElementById(id);
    var myvalue;
    
    // Activate our Save Button.
    var savebut = window.parent.document.getElementById('save_source_button');
    savebut.setAttribute("disabled", false);
    
    // Get the value of our item based on 
    // ftype variable.
    if ( ftype == 'checkbox' ) {
         if ( item.checked ) {
           myvalue = 1;
         } else {
           myvalue = 0;
         }
    } else if ( ftype == 'radio' ) {
         myvalue = item.selectedItem.id;
    } else {
       myvalue = item.value;
    }
    

    // set the URL of the script we will post to.
    url   = siteURL()+"/request.php";

    // set the command 
    cmd = "changeElement";

    // build query string for the request.
    query = "mod=nosystem&pkg=contentsources&cmd="+cmd
    query += "&item="+id+"&value="+myvalue;

    // Call forum post function
    formPost(url,query,doNothing);
    // alert( id + ' ' + myvalue );

}

function saveSource()
{
    // set the URL of the script we will post to.
    url   = siteURL()+"/request.php";

    // set the command 
    cmd = "saveSource";

    // build query string for the request.
    query = "mod=nosystem&pkg=contentsources&cmd="+cmd

    // Call forum post function
    formPost(url,query,handleSaveResponse);
    // alert( id + ' ' + myvalue );
}

function handleSaveResponse(response)
{
    // Get the name of our content source.
    var name = document.getElementById('current_source').value;
    
    if ( response != 'success' ) {
        alert(response);
        return;
    }
    
    // 
    var savebut = document.getElementById('save_source_button');
    savebut.setAttribute('disabled',true);   
    alert(name + 'Successfully saved');
    
    // loadSourceDetails( name );
}

function addPiece()
{ 
   // Check to make sure there are no active changes to this source.
   var savebut = window.parent.document.getElementById('save_source_button');
     if ( savebut.getAttribute('disabled')=='false' ) { 
       var doclose = alert("You have to save your changes before adding a new piece.");
       return;
      }
   
   var new_piece = prompt("What would you like to call your new content piece?");
   if ( ! new_piece ) {
       return;
   }
   
   var currs = window.parent.document.getElementById('current_source').value;
   //alert(currs + ' ' + new_piece);
   window.parent.loadSourceDetails(currs, new_piece);
    
}

function jumpToNewPiece()
{
  document.getElementById('source_tabs').selectedIndex = 1;
  var savebut = window.parent.document.getElementById('save_source_button');
  savebut.setAttribute('disabled','false');
}

function switchToDbWizard( name )
{
    var mypa = window.parent;
    var main = mypa.parent;
    main.loadDbWizView( name );
}

// FUNCTIONS SPECIFIC TO VIEWING AND WORKING WITH CONTENT
function fetchFirstContent()
{
    var iframe = document.getElementById('view_content_frame');
    if ( iframe.getAttribute('src')==='' ) {
        fetchContent();
    }

}
function refreshContent(name, page)
{
    if ( ! name ) { 
       name = document.getElementById('current_source').value;
    }
    if ( ! page ) {
        page = 1;
    }
    var iframe = document.getElementById('view_content_frame');
    iframe.setAttribute('src','');
    fetchContent( name, page );
}
function fetchContent(name, page)
{
      //alert(name);
      if ( ! name ) { 
         name = document.getElementById('current_source').value;
      }
      if ( ! page ) {
          page = 1;
      }
      var iframe = document.getElementById('view_content_frame');

      var query = 'mod=nosystem&pkg=contentsources&cmd=viewContent';
      var props = '&source='+name+'&page='+page;
      //iframe.setAttribute('src','');
      iframe.setAttribute('src',siteURL()+'/request.php?'+ query + props);
}
function fetchForm(name, tpl)
{
	  if ( ! tpl ) tpl = 'html';
      var iframe = document.getElementById('add_content_frame');
      var query = 'mod=nosystem&pkg=contentsources&cmd=addContent';
      var props = '&source='+name+'&tpl='+tpl;
      iframe.setAttribute('src',siteURL()+'/request.php?'+ query + props);
}
function fetchEditForm(name, tpl, id)
{
	  if ( ! tpl ) tpl = 'html';
      if ( ! name ) { 
          name = document.getElementById('current_source').value;
      }
      var iframe = document.getElementById('edit_content_frame');
      var query = 'mod=nosystem&pkg=contentsources&cmd=editContent';
      var props = '&source='+name+'&tpl='+tpl;
      if ( id ) { 
          props += "&itemid="+id;
      }
      iframe.setAttribute('src',siteURL()+'/request.php?'+ query + props);
}

function toggleEditButton(){
    var prime = parent.window.document.getElementById('source_prime').value;
    var tree = document.getElementById('content_tree');
    var itemid=tree.view.getCellText(tree.currentIndex,prime);
    if ( itemid ) {
        var butt = document.getElementById('myedit_button');
        butt.setAttribute('disabled',false);
        var dbutt = document.getElementById('delete_button');
        dbutt.setAttribute('disabled',false);
    }
}


function editContent(){
    var prime = parent.window.document.getElementById('source_prime').value;
    var mytabs = parent.window.document.getElementById('source_tabs');
    var tree = document.getElementById('content_tree');
    var itemid=tree.view.getCellText(tree.currentIndex,prime);
    window.parent.fetchEditForm('','',itemid);
    mytabs.selectedIndex = 1;
}
function deleteContent(){
    //alert('coming soon');
    var prime = parent.window.document.getElementById('source_prime').value;
    var tree = document.getElementById('content_tree');

    var start = new Object();
    var end = new Object();
    var numRanges = tree.view.selection.getRangeCount();
    
    var itemid = 0;
    var delstr = '';

    for (var t=0; t<numRanges; t++){
      tree.view.selection.getRangeAt(t,start,end);
      for (var v=start.value; v<=end.value; v++){
          itemid=tree.view.getCellText(v,prime);
          delstr += '|'+itemid;
      }
    }

    var mypar = parent.window;
    var curr_name = mypar.parent.window.document.getElementById('current_source').value;

    // set the URL of the script we will post to.
    url   = siteURL()+"/request.php";

    // set the command 
    cmd = "deleteContentRange";

    // build query string for the request.
    query = "mod=nosystem&pkg=contentsources&cmd="+cmd+"&source="+curr_name+"&delstr="+delstr;

    // Call forum post function
    formPost(url,query,loadFirstPage);
    // alert( id + ' ' + myvalue );

   // var itemid=tree.view.getCellText(tree.currentIndex,prime);
   // window.parent.fetchEditForm('','',itemid);
   // mytabs.selectedIndex = 1;
}

function changeLimit()
{
    var sellimit = document.getElementById('set_page_limit');
    tellServer('content_limit', sellimit.value, loadFirstPage );
}

function loadFirstPage()
{
    parent.window.refreshContent('',1);
}

function prevPage()
{
    var prev = document.getElementById('paginate_prev');
    parent.window.refreshContent('',prev.value);
}

function nextPage()
{
    var next = document.getElementById('paginate_next');
    parent.window.refreshContent('',next.value);
}

function filterContent()
{
    var name = parent.window.document.getElementById('current_source').value;
    var fstr = document.getElementById('content_search_str').value;
    var ffield = document.getElementById('content_search_field').value;


    var fullstr = ffield+'|'+fstr;
    tellServer(name+'_fstr', fullstr, loadFirstPage );

}




