
function loadPageDetails( page, addsource )
{
	// Check to see if the tree is selected  if not provided
    var par = window.parent;
    var iframe = document.getElementById('page_details_frame');
    var currp = document.getElementById('current_webpage');
    var tree = document.getElementById('page_tree');
    if ( ! page ) {
        page=tree.view.getCellText(tree.currentIndex,"value");
    }

    if( ! page || page == '' ){
       iframe.setAttribute('src','');
       return;
    }

    // add page to 'current_page' hidden label
    currp.value = page;

    var query = "?mod=nosystem&pkg=webpages&cmd=WebPageDetails";
    query += "&page="+page;
    if ( addsource ) {
      query += "&newsource="+addsource;
    }

    // Clear the page_details_frame
    iframe.setAttribute('src','');
    // Open the 'save/close' box 
    document.getElementById('close_webpage_button').setAttribute('disabled',false);
    // set new src
    iframe.setAttribute('src', par.siteURL()+'/request.php'+query );
}


function closePage()
{
    var tree = document.getElementById('page_tree');
    tree.selectedIndex = null;
    var iframe = document.getElementById('page_details_frame');
    iframe.setAttribute('src','');
    document.getElementById('close_webpage_button').setAttribute('disabled',true);
}


function refreshPage(response)
{
    closePage();
	var page = document.getElementById('page_name').value;
	window.parent.loadPageDetails(page);
}

function savePage()
{
    // set the URL of the script we will post to.
    url   = window.parent.siteURL()+"/request.php";

    // set the command 
    cmd = "saveList";

    // build query string for the request.
    query = "mod=nosystem&pkg=listmngr&cmd="+cmd

    // Call forum post function
    formPost(url,query,handleSaveResults);
}

function handleSaveResults(response)
{
	alert(response);
	// Check to see if new values have been added
	refreshPage();

}

function createPage()
{
	var page = document.getElementById('newpage_name').value;
	if ( ! page ) {
		alert("Provide a name for your page");
	}

    // Add Page to our page list under custom page
	loadPageDetails( 'nopages/mypages/'+page );
	
}

function toggleAddSource()
{
    var sel = document.getElementById('add_content');
    var placeholder = document.getElementById('sel_placeholder');
    var sources = document.getElementById('all_sources');
    var lists = document.getElementById('all_lists');
    var langs = document.getElementById('all_trans');
    var addbutt = document.getElementById('add_source_button');

    addthis = sel.selectedItem.value;

    placeholder.style.display = 'none';
    addbutt.setAttribute('disabled',false);
    if ( addthis == 'source' ) {
        sources.style.display = '';
        lists.style.display = 'none'
        langs.style.display = 'none';
    }else if ( addthis == 'list'){
        lists.style.display = '';
        sources.style.display = 'none'
        langs.style.display = 'none';
    }else if ( addthis == 'language'){
        langs.style.display = '';
        lists.style.display = 'none';
        sources.style.display = 'none'
    }else{
        lists.style.display = 'none';
        sources.style.display = 'none';
        langs.style.display = 'none';
        placeholder.style.display = '';
        addbutt.setAttribute('disabled',true);

    }

}


function changeValue( field )
{
	activateSave();
//	alert( field );
	var myvalue = document.getElementById(field).value;
	
    // set the URL of the script we will post to.
    url   = window.parent.siteURL()+"/request.php";

    // set the command 
    cmd = "changeValue";

    // build query string for the request.
    query = "mod=nosystem&pkg=webpages&cmd="+cmd
    query += "&item="+field+"&value="+myvalue;

    // Call forum post function
    formPost(url,query,doNothing);
}

function changeIsTheme()
{
	activateSave();
    var istheme = document.getElementById('is_theme');
    var seltheme = document.getElementById('theme');
    var myvalue = 0;
    if ( istheme.checked ) {
      myvalue = 1;
      seltheme.setAttribute('disabled', true);
    }else{
      seltheme.setAttribute('disabled', false);
    }
    // set the URL of the script we will post to.
    url   = window.parent.siteURL()+"/request.php";
    // set the command 
    cmd = "changeValue";
    // build query string for the request.
    query = "mod=nosystem&pkg=webpages&cmd="+cmd
    query += "&item=is_theme&value="+myvalue;
    // Call forum post function
    formPost(url,query,doNothing);
}

function changeSourceValue( id )
{
	activateSave();
	
	var name = document.getElementById(id + '_name').value;
	var source = document.getElementById(id + '_source').value;
	var fetch = document.getElementById(id + '_fetch');
	var render = document.getElementById(id + '_render');
	var filter = document.getElementById(id + '_filter');

    var isfetch = ( fetch.checked ) ? '1' : '0';
    var isrender = ( render.checked ) ? '1' : '0';
    var isfilter = ( filter.checked ) ? '1' : '0';

    // check to see if render is checked. if it is, fetch must
    // also be checked
    if ( render.checked && ! fetch.checked ) {
        fetch.checked = true;
    }

    // set the URL of the script we will post to.
    url   = window.parent.siteURL()+"/request.php";

    // set the command 
    cmd = "changeSourceValue";

    // build query string for the request.
    query = "mod=nosystem&pkg=webpages&cmd="+cmd
    query += "&id="+id+"&name="+name+"&source="+source
    query += "&fetch="+isfetch+"&render="+isrender+"&filter="+isfilter;

    // Call forum post function
    formPost(url,query,doNothing);
}

function activateSave()
{
	var savebut = window.parent.document.getElementById('save_webpage_button');
	savebut.setAttribute('disabled', false);
	
}
function deactivateSave()
{
	var savebut = document.getElementById('save_webpage_button');
	savebut.setAttribute('disabled', true);
}

function isSaveDisabled()
{
	var savebutt = window.parent.document.getElementById('save_webpage_button');
	return savebutt.getAttribute('disabled');
}

function saveWebPage()
{
    // set the URL of the script we will post to.
    url   = window.parent.siteURL()+"/request.php";
    // set the command 
    cmd = "saveWebPage";
    // build query string for the request.
    query = "mod=nosystem&pkg=webpages&cmd="+cmd
    // Call forum post function
    formPost(url,query,handleSaveWebPageResults);

}

function handleSaveWebPageResults(response)
{
	alert(response);
    addToPageList();
	deactivateSave();
	
}

// This funciton takes the current page_name and checks 
// To see if this is added to the Pages List.
function addToPageList()
{
/** 
 *  HAVING PROBLEMS ADDING NEW ROWS TO A TREE WITHOUT JUST REBUILDING
 *  THE ENTIER TREE.
 *  var currp = document.getElementById('current_webpage').value;
    var myArray = currp.split('/');
    var page = myArray[2];
    var tree = document.getElementById('page_tree');
    var found = false;
    var str = '';
    var children = tree.childNodes; 
    for(var i=0;i<children.length;i++){
     for(var n=0;n<tree.childNodes[i].childNodes.length;n++){
        str = tree.view.getCellText( tree.childNodes[i].childNodes[n],"label");
        alert( str + ' ' + page );
        if ( str == page ) {
            found = true;
        }
     }
    }
    if ( ! found ) {
        //list.appendItem( myvalue );
    }
   // alert(found+' '+mylist+' '+myvalue); */
}

function submitAddSource()
{
	//alert( isSaveDisabled() );
	if ( isSaveDisabled()=='false' ){
	    alert('Please save current changes before adding content to this page.');
	    return;
	}
	
	// get current page
	var page = document.getElementById('page_name').value;
	var pkg = document.getElementById('package').value;
	var mod = document.getElementById('module').value;
	var type = document.getElementById('add_content').selectedItem.value;
	var source = document.getElementById('all_sources').selectedItem.value;
	var lang = document.getElementById('all_trans').selectedItem.value;
	
	if ( type == 'source' ) {
	  var addthis = 'source/'+source; 
	} else {
      var addthis = 'langfile/'+lang;
    }
	activateSave();
	
    //
    var cpage = document.getElementById('current_webpage');
	window.parent.loadPageDetails( mod+'/'+pkg+'/'+page, addthis );
}

function removeSource( id ) {
     var res = confirm("Are you sure you want to remove this content source ? " +id);
     if ( ! res ){
        return;
     }
     
	// Send a command to the server telling it to remove the 
    // set the URL of the script we will post to.
    // set the URL of the script we will post to.
    url   = window.parent.siteURL()+"/request.php";

    // set the command 
    cmd = "removeSource";

    // build query string for the request.
    query = "mod=nosystem&pkg=webpages&cmd="+cmd
    query += "&id="+id;

    // Call forum post function
    formPost(url,query,saveAndReload);
}
function removeLangFile( id ) {
     var res = confirm("Are you sure you want to remove this language file ? " +id);
     if ( ! res ){
        return;
     }
    url   = window.parent.siteURL()+"/request.php";
    // set the command 
    cmd = "removeLangFile";
    // build query string for the request.
    query = "mod=nosystem&pkg=webpages&cmd="+cmd
    query += "&id="+id;
    // Call forum post function
    formPost(url,query,saveAndReload);
}

function saveAndReload(response){
    // set the URL of the script we will post to.
    url   = window.parent.siteURL()+"/request.php";
    // set the command 
    cmd = "saveWebPage";
    // build query string for the request.
    query = "mod=nosystem&pkg=webpages&cmd="+cmd
    // Call forum post function
    formPost(url,query,reloadSelf);
}

function reloadSelf(response)
{
	var page = document.getElementById('page_name').value;
	var pkg = document.getElementById('package').value;
	var mod = document.getElementById('module').value;
    parent.window.loadPageDetails(mod+'/'+pkg+'/'+page);
}


function reloadFrame( fname )
{
	var iframe = document.getElementById(fname);
	var myloc = iframe.getAttribute('src');
	iframe.setAttribute('src', '' );
	iframe.setAttribute('src', myloc );
	
}

function addInclude()
{
    activateSave();
    var page = document.getElementById('select_include');
    var assto = document.getElementById('include_assign');

    if ( ! page.value || ! assto.value ) {
        alert("Please select a page and provide a name which to assign the page to.");
        return false;
    }
    // set the URL of the script we will post to.
    url   = window.parent.siteURL()+"/request.php";
    // set the command 
    cmd = "addInclude";
    // build query string for the request.
    query = "mod=nosystem&pkg=webpages&cmd="+cmd
    query = query+"&page="+page.value+"&assign="+assto.value+"&label="+page.getAttribute('label');
    // Call forum post function
    formPost(url,query,getIncludeTree);

}

function getIncludeTree(response)
{
    // set the URL of the script we will post to.
    url   = window.parent.siteURL()+"/request.php";
    // set the command 
    cmd = "getIncludeTree";
    // build query string for the request.
    query = "mod=nosystem&pkg=webpages&cmd="+cmd
    // Call forum post function
    formPost(url,query,loadIncludeTree);
}

function loadIncludeTree(response)
{
    //alert(response);
    var tree=document.getElementById('include_tree');

    emptyIncludeTree();

    var doc = "";
    var boxContainerOpen = '<treechildren id="statement_children" xmlns="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul">'
    var boxContainerClose = '</treechildren>';
    doc = (new DOMParser()).parseFromString(boxContainerOpen + response + boxContainerClose, "text/xml");
    // For every node of our xml_str append as a child item to XUL element insert_at
    //alert(xul_str);
    for (var i=0;i < doc.childNodes.length;i++) {
        tree.appendChild(tree.ownerDocument.importNode(doc.childNodes[i],true));
    } 
}

function emptyIncludeTree()
{
    var tree = document.getElementById('include_tree');
    var children = tree.childNodes.length; 
    for(var i=0;i<children;i++){
     if ( tree.childNodes[i].tagName == 'treechildren' ) {
         tree.removeChild(tree.childNodes[i]);
     }
    }

}

function removeSelectedIncludes()
{
    activateSave();
    var res = confirm("Are you sure you want to remove these included pages?")

    if ( ! res ) {
        return false;
    }

    var tree = document.getElementById('include_tree');
    var start = new Object();
    var end = new Object();
    var numRanges = tree.view.selection.getRangeCount();
    var itemid = 0;
    var delstr = '';
    for (var t=0; t<numRanges; t++){
      tree.view.selection.getRangeAt(t,start,end);
      for (var v=start.value; v<=end.value; v++){
          itemid=tree.view.getCellText(v,'colassigned');
          delstr += '|'+itemid;
      }
    }

    // set the URL of the script we will post to.
    url   = window.parent.siteURL()+"/request.php";
    // set the command 
    cmd = "removeIncludes";
    // build query string for the request.
    query = "mod=nosystem&pkg=webpages&cmd="+cmd;
    query = query + "&delstr="+delstr;
    // Call forum post function
    formPost(url,query,getIncludeTree);

}

function loadSelectedInclude()
{
   //var res = confirm("Are you sure you want to remove these included pages?")
   // if ( ! res ) {
   //     return false;
   //}
}

/*
function toggleCheckAll()
{
	//
	var totalv = document.getElementById('total_values').value;
	var master = document.getElementById('master_checkbox');
	
	if ( master.getAttribute('checked') ) {
	   var onoff = true;
 	} else {
 	   var onoff = false;
 	}
 	
	// loop through each and check
	for(var i=0;i<totalv;i++)
	{
	     document.getElementById(i+'_flag').setAttribute('checked', onoff);
	}
}

function toggleAddValueForm()
{
	var addform = document.getElementById('add_value_form');
	if ( addform.style.display == 'none' ){
		addform.style.display = '' 
	} else {
		addform.style.display = 'none' 
	}
}

function deleteCheckedValues()
{
	// Find all indexes that are checked
	var totalv = document.getElementById('total_values').value;
 	
	// loop through each and check
	var del = '';
	for(var i=0;i<totalv;i++)
	{
		if (document.getElementById(i+'_flag').getAttribute('checked') ) {
			del += i+'|';
		}
	}
    // set the URL of the script we will post to.
    url   = window.parent.siteURL()+"/request.php";

    // set the command 
    cmd = "deleteValues";

    // build query string for the request.
    query = "mod=nosystem&pkg=listmngr&cmd="+cmd
    query += "&del="+del;

    // Call forum post function
    formPost(url,query,saveList);
	
}
*/ 
