<?php
// $Id: rdfmodeler_index.php,v 1.2 2005/02/26 01:48:19 kerkness Exp $

         // Check to see if we have a model in memory.
         // Load an instance of our RdfModele class using the
         // the memory model if present.
         require_once('class/rdfmodel.php');
         $model_name = '';
         if ( isset( $_SESSION['mem']['model_name'] ) && $_SESSION['mem']['model_name'] ) {
            $model_name = $_SESSION['mem']['model_name']; 
            error_log("just set variable from session $model_name");
         }else{
            $_SESSION['mem']['model_name'] = $model_name; 
            error_log("model name is blank");
         }

         // 
         $rdfmod = new NoAhRdfModel( $model_name );

         // Check to see if our command requires we run
         // a function from our class.
         if ( $noAh->hasFunc() ) {
             $functions = $noAh->getFunc();
             for($i=0;$i<count($functions);$i++){
                 switch($functions[$i]){
                 case 'loadStatementTree':
                     // If the 'getfile' value is called, load a new file as our model.
                     if ( isset($_GET['getfile']) ) {
                         $rdfmod->loadXML( $_GET['getfile'] );
                     }
                     $statements = $rdfmod->getStatementArr();
                     $noAh->addContent('statements', $statements);
                     $noAh->addContent('ns', $rdfmod->getListItems('updateSubjectList') );
                 break;
                 case 'updateSubjectList':
                     $fetchlist = true;
                     $noAh->addContent('listname', 'subject');
                     break;
                 case 'updatePredicateList':
                     $fetchlist = true;
                     $noAh->addContent('listname', 'predicate');
                     break;
                 case 'updateObjectList':
                     $fetchlist = true;
                     $noAh->addContent('listname', 'object');
                     break;
                 case 'clearMemModel':
                     $rdfmod->clearModel();
                     $noAh->addContent('results', '' );
                     break;
                 case 'getSource':
                     $rdfmod->buildModel();
                     $myxml = $rdfmod->serializeXML();
                     $noAh->addContent('results', $myxml );
                     break;
                 case 'saveModel':
                     
                     // Get the model name;
                     $model_name = $_GET['saveas'];

                     // add XML extension if not present already.
                     $ext = substr($model_name,-4);
                     if (strtolower($ext)!='.xml') {
                         $model_name .= '.xml';
                     }
                     
                     // Set the new model_name
                     $rdfmod->setName($model_name);
                     
                     // Check to see if there is already a file.
                     // Make a backup copy if there is.
                     $backedup = false;
                     if ( $rdfmod->hasFile() ) {
                         if ( ! $rdfmod->backupModel( $model_name.'.bak' ) ){
                             $err = "Failed to backup $model_name, changes were not saved.";
                         }else{
                             $backedup = true;
                         }
                     }

                     // Save our model to a file
                     if ( isset($err) ) {
                         $results = $err;
                     }else{
                         $saved = $rdfmod->saveModel();
                         if ( $saved ) {
                             $results = "RDF file was successfully saved.";
                         } else {
                             $results = "Failed to successfully save your file.";
                         }
                     }

                     if ( $backedup ) {
                         $results .= "\nA Backup of the existing $model_name file was created.";
                     }

                     // Return results.
                     $noAh->addContent('results', $results );
                     break;
                 case 'deleteStatement':
                     // Is the submitted statement an existing statement?
                     $id = $rdfmod->isStatement($_POST['sub'],$_POST['prd'],$_POST['obj']);
                     if ( $id >= 0 ) {
                         $rdfmod->deleteStatement($id);
                     }
                     $statements = $rdfmod->getStatementArr();
                     $noAh->addContent('statements', $statements);
                     $noAh->addContent('ns', $rdfmod->getListItems('updateSubjectList') );

                     break;
                 case 'submitStatement':

                     // Is the submitted statement an existing statement?
                     $id = $rdfmod->isStatement($_POST['sub'],$_POST['prd'],$_POST['obj']);

                     if ( isset($id) && ( $id === 0 || $id > 0 ) ) {
                         // Statement already exists.
                         error_log("Duplicate Statement, no changes made");
                         error_log($_POST['sub'].", ".$_POST['prd'].", ".$_POST['obj']." : ".$id );
                     }else{

                         if ( $_POST['esub'] ) {
                             // get the ID of the statement we need to edit.
                             $id = $rdfmod->isStatement($_POST['esub'],$_POST['eprd'],$_POST['eobj']);
                             // Update the statement
                             $rdfmod->updateStatement($id,$_POST['sub'],$_POST['prd'],$_POST['obj']);
                             error_log("Edited Statement");
                         } else {
                             $rdfmod->addStatement($_POST['sub'],$_POST['prd'],$_POST['obj']);
                             error_log("Added New Statement");
                         }

                     }

                     $statements = $rdfmod->getStatementArr();
                     $noAh->addContent('statements', $statements);
                     $noAh->addContent('ns', $rdfmod->getListItems('updateSubjectList') );
                     break;
                 }

                 if( isset($fetchlist) && $fetchlist ){
                     // Add all current subjects to menuitems.
                     $items = $rdfmod->getListItems($functions[$i]);
                     $noAh->addContent('menuitems', $items );
                 }

                 // error_log("call function " . $functions[$i] );
                 //$rdfmodel->$functions[$i]();
             }
         }

         // Update our Session ['mem'] with details from our rdfmod object
         $rdfmod->updateMemory();

         // Run the function.


         // Check to see if our cmd is to load a model.


?>
