<?php
// $Id: listmngr_gui.php,v 1.5 2005/03/13 07:20:16 kerkness Exp $

   /**
    * This file is part of NoAh.
    * 
    * NoAh is free software; you can redistribute it and/or modify
    * it under the terms of the GNU General Public License as published by
    * the Free Software Foundation; either version 2 of the License, or
    * (at your option) any later version.
    * 
    * NoAh is distributed in the hope that it will be useful,
    * but WITHOUT ANY WARRANTY; without even the implied warranty of
    * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    * GNU General Public License for more details.
    * 
    * You should have received a copy of the GNU General Public License
    * along with NoAh; if not, write to the Free Software
    * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    */

   /**
    * - 
    */
    
  // Set the default value for the help file to display on this page
  $noAh->addContent('helpdoc', 'lists.html');
    
  $dpath = XML_PATH;    // path for domain xml files
  $cpath = CORE_PATH.'/xml'; // path to core noah xml files

  // Get the files from both main xml directories
  $dfiles = listFiles($dpath);
  $cfiles = listFiles($cpath);

  // Merge files into a single array
  $allfiles = array_merge($dfiles,$cfiles);   
  
  // Check to see if a specific list should be loaded.
  if ( isset($_GET['list']) && $_GET['list'] ) {
     $load_list = $_GET['list']; 
  } else {
     $load_list = '';
  }
  
  // Create two arrays to hold details about current list.
  $list = array();
  $values = array();
  
  $myList = new NoAhContentList( $load_list );
  
  $list = $myList->getListDetails();
  $values = $myList->getListValues();
  
  // Let's add our list details to our session so
  // we can update it via remote calls
  $_SESSION['mem']['list'] = $list;
  $_SESSION['mem']['values'] = $values;
 
  // Check to see if user has a display_mode set.
  $view_mode = 'display';
  if ( isset($_SESSION['mem']['view_mode']) && $_SESSION['mem']['view_mode']) {
     $view_mode = $_SESSION['mem']['view_mode'];
  }
 
  // Add content to template
  $noAh->addContent('load_list',$load_list);
  $noAh->addContent('lists', $allfiles );
  $noAh->addContent('mylist',$list);
  $noAh->addContent('myvalues',$values);
  $noAh->addContent('total_values',count($values));
  $noAh->addContent('view_mode',$view_mode);
  
  // Load a list of List Categories
  $lcat = new NoAhContentList('listcategories');
  $noAh->addContent('lcat',$lcat->getListValues());

  function listFiles( $path )
  {
    $source = array();
    // First loop over path and file just the files.
    if ($handle = opendir($path)) {
       while (false !== ($file = readdir($handle))) {
           if ($file != "." && $file != ".." && $file != "CVS") {
               $myfiles[] = $file;
           }
       }
       closedir($handle);
    }
    // Loop over each file and find just the content lists.
    foreach($myfiles as $i=>$file)
    {
        if ( $sfile = strstr($file,'list_') ) {
            // Strip .xml extension off the end
            $sfile = str_replace('.xml','',$sfile);
            // Strip source off the front
            $sfile = str_replace('list_','',$sfile);
            $source[] = $sfile;
        }
    }

    return $source;
  }


?>
