<?php
// $Id: listmngr_savelist.php,v 1.3 2005/03/22 02:01:21 kerkness Exp $

   /**
    * This file is part of NoAh.
    * 
    * NoAh is free software; you can redistribute it and/or modify
    * it under the terms of the GNU General Public License as published by
    * the Free Software Foundation; either version 2 of the License, or
    * (at your option) any later version.
    * 
    * NoAh is distributed in the hope that it will be useful,
    * but WITHOUT ANY WARRANTY; without even the implied warranty of
    * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    * GNU General Public License for more details.
    * 
    * You should have received a copy of the GNU General Public License
    * along with NoAh; if not, write to the Free Software
    * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    */

   /**
    * - 
    */
    
  
  $myList = new NoAhContentList( 'fakename' );
  $myList->loadFromMemory();
  $list = $myList->getListDetails();
  
  // Check for new values
  if ( $list['newvalue'] ){

    $new = $list['newvalue'];
    $nlabel = (isset($new['label'])) ? $new['label'] : '' ;
    $nthisvalue = (isset($new['value'])) ? $new['value'] : '' ;
    $ndesc = (isset($new['desc'])) ? $new['desc'] : '' ;
    $norder = (isset($new['order'])) ? $new['order'] : 55 ;

    foreach($new as $x=>$y) error_log("$x == $y");
    
  	$myList->addValue($nlabel, $nthisvalue, $ndesc, $norder);
  }
  
  $values = $myList->getListValues();
  
// Include our rdfmodeler class file.
require_once( MOD_PATH.'/class/rdfmodel.php' );


/**
 * Start save source process.
 * 
 * 
 * 
 *
 */

$mymodel = new NoAhRdfModel();

// DEFINE STATEMENTS FOR LIST HEADER INFROMATION

// Set our Source URL
$luri = '../ns/list/' . str_replace( ' ','',$list['label']);
$mymodel->addStatement($luri,'RDF:type','RDF:Seq');

// label
$mymodel->addStatement($luri,'noah:label',$list['label']);
// name
$mymodel->addStatement($luri,'noah:name',$list['name']);
// table


// DEFINE STATEMENTS FOR EACH CONTENT PIECE

foreach($values as $i =>$myvalue )
{   
   
   // Set the url for our piece.
   $uri = '../ns/listitem/'. str_replace(' ','', $myvalue['label']);
   
   // Add to our pieces sequence
   $mymodel->addStatement($luri,'RDF:li',$uri);
   
   // Add statements specific for this piece.
   $mymodel->addStatement($uri,'noah:label',$myvalue['label']);
   $mymodel->addStatement($uri,'noah:value',$myvalue['value']);
   if (isset($myvalue['desc'])) $mymodel->addStatement($uri,'noah:desc',$myvalue['desc']);
   if (isset($myvalue['order'])) $mymodel->addStatement($uri,'noah:order',$myvalue['order']);
   
   // kill our URI to prevent accidentally using it again
   unset($uri);

}

// SET DEFAULT STATEMENTS WHICH NEED TO BE INCLUDED IN ALL SOURCES

// Set the name of our model
$mymodel->setName( $myList->normalizeName($list['name']) );

// Save our model
if ( ! $mymodel->saveModel() ){
     $results = "Failed to Save Content Source File.";
} else {
     $results = "success";
}

$noAh->addContent('results',$results);

  
?>