<?php

// $Id: source_details.php,v 1.5 2005/03/22 02:01:21 kerkness Exp $

   /**
    * This file is part of NoAh.
    * 
    * NoAh is free software; you can redistribute it and/or modify
    * it under the terms of the GNU General Public License as published by
    * the Free Software Foundation; either version 2 of the License, or
    * (at your option) any later version.
    * 
    * NoAh is distributed in the hope that it will be useful,
    * but WITHOUT ANY WARRANTY; without even the implied warranty of
    * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    * GNU General Public License for more details.
    * 
    * You should have received a copy of the GNU General Public License
    * along with NoAh; if not, write to the Free Software
    * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    */

  // This script grabs all the details about single content source
  // and provides the content for a details view of a content source
  // including forms and data to edit all metadata about the content source
  // Load ALL Page METADATA
  $open_source = ( isset($_GET['source']) )?$_GET['source']:0;
  $open_source = ( isset($_POST['source']) )?$_POST['source']:$open_source;
  
  $noLang->loadTranslation('content_manager');
  if ( ! $open_source ) {
      $noAh->_noEh("Invalid Source Name".$open_source, E_USER_ERROR);
  }
  
  $mySource = new NoAhContentSource($open_source);
  $mySource->loadSourceFile();

  // Check to see if a request to add a anew piece is bieng made
  // if so, add a blank piece to our form 
  if ( isset($_GET['new_piece']) ) {
    require_once(CORE_PATH.'/class/noahlib/NoAhContentPiece.php');
    $mySource->addPiece( new NoAhContentPiece( str_replace(' ','',$_GET['new_piece']) ) );
    $noAh->addContent('showlastfield',1);
  }

  // Get all our pieces
  $pieces = $mySource->getPieces();
  
  // START BUILDING ALL THE PAGE FORMS.
  // Include XULForm classes
  require_once(CORE_PATH."/class/xulform/xulformloader.php");

  // Create new form for building Source Details form
  $xform = new xulform();
  $elem = array();

  // Create Elements for Source Details Form
  $elem['txtlabel'] = new xultextbox('label','Label',$mySource->label);
  $elem['txtlabel']->setCommand('onchange',"changeElement('label')");
  
  $elem['txtname'] = new xultextbox('name','Name',$mySource->name);
  $elem['txtname']->setCommand('onchange',"changeElement('name')");
  
  $elem['txttable'] = new xulbutton('table','Table', $mySource->table.' : open wizard' );
  $elem['txttable']->setCommand('oncommand',"switchToDbWizard('".$mySource->table."')");
  
  $elem['txtprime'] = new xullabel('prime','Primary Key',$mySource->prime);
  
  $elem['txttype'] = new xullabel('type','Type','MySQL Database');
  
  $elem['txtdbconn'] = new xultextbox('dbconn','Connection', $mySource->dbconn );
  $elem['txtdbconn']->setCommand('onchange',"changeElement('dbconn')");
  
  // NOTE: WE COULD CHANGE THIS TO READ FROM A CONTENT LIST
  // ALTHOUGH JUST HARD CODING THESE MEANS THE CODE WILL RUN FASTER
  // IT LEAVE THE 'ACCESS' LEVELS UN EXTENDABLE.  
  //$elem['txttype'] = new xulmenulist('type','Type',$mySource->type);
  //$elem['txttype']->addOption('Database','database');
  //$elem['txttype']->addOption('RSS','rss');
  //$elem['txttype']->setCommand('oncommand',"changeElement('type')");
  //$elem['txttype']->setProperty('disabled','true');
  //$elem['txttype']->setProperty('flex','1');
  
  // NOTE: WE COULD CHANGE THIS TO READ FROM A CONTENT LIST
  // ALTHOUGH JUST HARD CODING THESE MEANS THE CODE WILL RUN FASTER
  // IT LEAVE THE 'ACCESS' LEVELS UN EXTENDABLE.
  $elem['selaccess'] = new xulmenulist('access','Access', $mySource->access );
  $elem['selaccess']->addOption('Public','public');
  $elem['selaccess']->addOption('Private','private');
  $elem['selaccess']->setCommand('oncommand',"changeElement('access')");

  $elem['allowedit'] = new xulradiogroup('allowedit','Allow Edit', $mySource->allowedit, 'horz');
  $elem['allowedit']->addOption('Yes','yes');
  $elem['allowedit']->addOption('No','no');
  $elem['allowedit']->setCommand('oncommand',"changeElement('allowedit', 'radio')");

  // Add elements to our form
  $xform->addElements($elem);

  // Get our elements
  $fdetails = $xform->fetchElements();
  
  // Kill our form objcet
  unset($xform);
  unset($elem);
  
  // Load a list of field input options
  // NOTE TURN THIS INTO NoAHContentList Class.
  // NOTE TURN THIS INTO NoAHContentList Class.
  // NOTE TURN THIS INTO NoAHContentList Class.
  require_once(CORE_PATH.'/class/noahlib/NoAhRap.php');
  $nrap = new NoAhRap( CORE_PATH.'/xml/list_system_fieldtypes.xml');
  $xdata = $nrap->getData();
  unset($nrap);
  foreach($xdata['list/FieldTypes'] as $k=>$v){
      if (is_int($k)) {
          $my = $xdata[$v];
          $inputs[$my['label']] = $my['value'];
      }
  }
  

  // *************  RENDER PIECES FORM ELEMENTS
  foreach ($pieces as $i=>$piece )
  {
      $mypiece = $piece->pieceDetails();
      // Build a FORM Specifically for this piece.
      $mypiece['label'] = ( $piece->label ) ? $piece->label : $piece->name;
      $elem['label'] = new xultextbox( $i.'_label','Label', $mypiece['label']);
      $elem['label']->setCommand('onchange',"changeElement('".$i."_label')");

      $elem['name'] = new xultextbox( $i.'_name','Field',$piece->name );
      $elem['name']->setCommand('onchange',"changeElement('".$i."_name')");

      $elem['input'] = new xulmenulist( $i.'_input','Input Type', $piece->input );
      $elem['input']->addOptionArray($inputs);
      $elem['input']->setCommand('oncommand',"changeElement('".$i."_input')");

      $isreq = ( isset( $piece->required ) ) ? $piece->required : 0 ;
      $elem['required'] = new xulcheckbox( $i.'_required','Required', $isreq );
      $elem['required']->setCommand('oncommand',"changeElement('".$i."_required', 'checkbox')");

      $ord = ( isset( $piece->order ) ) ? $piece->order : 55 ;
      $elem['order'] = new xultextbox( $i.'_order','Order', $ord );
      $elem['order']->setCommand('onchange',"changeElement('".$i."_order')");

      $len = ( isset( $piece->length ) ) ? $piece->length : '' ;
      $elem['length'] = new xultextbox( $i.'_length','Length',$len );
      $elem['length']->setCommand('onchange',"changeElement('".$i."_length')");

      $def = ( isset( $piece->default ) ) ? $piece->default : '' ;
      $elem['default'] = new xultextbox( $i.'_default','Default',$def );
      $elem['default']->setCommand('onchange',"changeElement('".$i."_default')");

      // Change the label of name depending on the type of content source.
      if ( ! isset($mySource->dbconn) ) {
          $elem['name']->setAttribute = new xultextbox( 'name','XML Tag',$piece->name );
      }
      
      // Get our elements
      $xform = new xulform();
      $xform->addElements($elem);
      $mypiece['form'] = $xform->fetchElements();
      
      unset($xform);
      unset($elem);
			
      $mypieces[] = $mypiece;
  }
  
  // Set the piece which should be displayed by default
  // This should be the first field or the last field if we are
  // adding a new one.
  if ( isset($_GET['new_piece']) ) {
    $noAh->addContent('showfieldindex', count($mypieces)-1 );
  }else{
    $noAh->addContent('showfieldindex', 0 );
  }
  
  
  // Clear any session variables which might be hanging around
  if ( isset($_SESSION['mem']['csource']) ) {
  unset($_SESSION['mem']['csource']);
  }
  if ( isset($_SESSION['mem']['cpieces']) ) {
  unset($_SESSION['mem']['cpieces']);
  }
  //unset($_SESSION['mem']['org_pieces']);

  // Add details about this source to our system memory
  $_SESSION['mem']['csource'] = $mySource->sourceDetails();
  $_SESSION['mem']['cpieces'] = $mypieces;
  //$_SESSION['mem']['org_pieces'] = $mypieces;
  
  // Assing content to of the page
  $noAh->addContent('fdetails', $fdetails);
  $noAh->addContent( 'pieces', $mypieces );
  $noAh->addContent( 'mysource', $mySource->sourceDetails() );
  
  //print '<pre>';
  //print_r($mypieces);
  //print_r(htmlentities($ele[0]['body']));
  //print_r(htmlentities($ele[1]['body']));
  //print '</pre>';
  //die();

?>
