<?php
// $Id: listmngr_gui.php,v 1.4 2005/03/11 04:07:32 kerkness Exp $

   /**
    * This file is part of NoAh.
    * 
    * NoAh is free software; you can redistribute it and/or modify
    * it under the terms of the GNU General Public License as published by
    * the Free Software Foundation; either version 2 of the License, or
    * (at your option) any later version.
    * 
    * NoAh is distributed in the hope that it will be useful,
    * but WITHOUT ANY WARRANTY; without even the implied warranty of
    * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    * GNU General Public License for more details.
    * 
    * You should have received a copy of the GNU General Public License
    * along with NoAh; if not, write to the Free Software
    * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    */
   
   // Take the page details that are in memory and update the 
   
   // print_r($_SESSION['mem']['page']);
   if ( ! isset($_SESSION['mem']['page']) && ! $_SESSION['mem']['page'] ) {
        $noAh->noEh('Access Denied - Cannot save page.', E_USER_ERROR );
   		exit;
   	}
   $page = $_SESSION['mem']['page'];
   
   // First let's create an NoAhRap object for our xml file
   // and get a copy of all the original xml data.
   require_once(CORE_PATH.'/modules/nosystem/class/rdfmodel.php');
   $pkgxml = new NoAhRdfModel();
   $pkgxml->loadxml( $page['package'] );
   $org_pkg = $pkgxml->getStatementArr();
   
   //print_r($org_pkg);
   
   // Loop over our page details.
   // Find the index for each statement, if it's present updates the 
   // statement. If it's not then add the statement
   $sub = "../ns/cmd/".$page['name'];
   foreach( $page as $key=>$value ){
      // By-pass the 'sources' key from our page array, as this data will
      // be written to a different file.
      if ( $key == 'sources' || $key == 'type' || $key == 'includes' || $key == 'translations' ) continue;
      
      // Search for our statement index.
      $id = $pkgxml->isStatement($sub,'noah:'.$key); 
     
   	  if ( $id !== false ){
   	      // Update Statement
   	  	  error_log("UPDATE STATEMENT $id = $sub, $key, $value ");
   	      $pkgxml->updateStatement( $id, $sub, 'noah:'.$key, $value );
   	  } else {
   	  	  // Add Statement
   	  	  error_log("ADDING NEW $id - $sub, $key, $value ");
   	  	  $pkgxml->addStatement( $sub, 'noah:'.$key, $value );
   	  }
   }
   
   // Make sure our page is par of our pages/ name space in our package file
   foreach( $org_pkg as $i=>$v )
   {
        if ( substr($v['sub'],0,12)=='../ns/pages/' ){
            $pagesuri = $v['sub'];
            break;
        }
   }
   $pid = $pkgxml->isStatement($pagesuri,'RDF:li',$sub);
   if( $pid === false ){
        $pkgxml->addStatement($pagesuri,'RDF:li',$sub);
   }
   
   
   // Backup and save our file
   $results = '';
   //$pkgxml->updateMemory();
   //$pkgxml->clearModel();
   $newxml = new NoAhRdfModel();
   $xml_name = str_replace('pkg_','',$page['package']);
   $xml_name = str_replace('.xml','',$xml_name);
   $newxml->setName($page['package']);
   //$pkgxml->loadFromMemory();
   $new_pkg = $pkgxml->getStatementArr();
   
   foreach( $new_pkg as $i => $statement )
   {
   		$newxml->addStatement($statement['sub'],$statement['prd'],$statement['obj']);
   }
   // print count($org_pkg)." -> ".count($new_pkg);
   
       /**   SAVE OUR FILE */
       
       // Set the new model_name
       // $pkgxml->setName($model_name);
                    
       // Check to see if there is already a file.
                     // Make a backup copy if there is.
     $backedup = false;
     if ( $newxml->hasFile() ) {
        if ( ! $newxml->backupModel( $page['package'].'.bak' ) ){
           $err = "Failed to backup ".$page['package'].", changes were not saved.";
           }else{
              $backedup = true;
           }
       }
       // Save our model to a file
       if ( isset($err) ) {
         $results = $err;
       }else{
         $saved = $newxml->saveModel();
         if ( $saved ) {
          $results = "Page settings were successfully saved.";
         } else {
          $results = "Failed to successfully save your file.";
         }
       }       
       if ( $backedup ) {
        $results .= "\nA Backup of the existing ".$page['package']." file was created.";
       }
       
   
   // NOW CHECK FOR AND UPDATE SOURCES FILE
   $mypage = new NoAhWebPage();
   $mypage->setAttributes($page);
   $save_source = false;
   $has_source = $mypage->hasSource();

   /**/
   if ( isset( $page['sources'] ) && $page['sources']  ){
         // Name of our Sources file
         $sfile = 'page_'.strtolower($page['name']).'.xml';
         // Create a new 
         $sxml = new NoAhRdfModel();
 		 $sxml->setName($sfile);
 		 // Build statements foe each source added to this page.
 		 $muri = '../ns/sources/'.$page['name'];
 		 //$sxml->addStatement($muri,'RDF:type','RDF:Seq');
 		 
         foreach( $page['sources'] as $i=>$data ){
 		     $uri = '../ns/source/'.$data['name'];
 		     //$sxml->addStatement($muri,'RDF:li',$uri);
 		     foreach( $data as $key=>$value) {
 		        $sxml->addStatement($uri,'noah:'.$key,$value);
 		     }
 		 }
         $save_source = true;
         unset($muri);
   } //*/
   
   // page['sources']
     

   // IF there is include details build the statements for
   // our source xml
   /**/
   if ( isset($page['translations']) && $page['translations'] ) {
       // Create an $sxml object but only if it isn;t created/
       if ( ! isset($sxml) ) {
           // Name of our Sources file
           $sfile = 'page_'.strtolower($page['name']).'.xml';
           $sxml = new NoAhRdfModel();
           $sxml->setName($sfile);
       }

       $turi = '../ns/translations/'.$page['name'];
       //$sxml->addStatement($turi,'RDF:type','RDF:Seq');
       foreach( $page['translations'] as $i=>$data ){
           $uri = '../ns/translation/'.$data['name'];
           //$sxml->addStatement($turi,'RDF:li',$uri);
           error_log("Adding $uri to $turi");
           foreach( $data as $key=>$value) {
               error_log("Adding $key == $value to $uri");
              $sxml->addStatement($uri,'noah:'.$key,$value);
           }
          unset($uri);
       }
       $save_source = true;
       unset($turi);
   } //*/

   // IF there is include details build the statements for
   // our source xml
   if ( isset( $page['includes'] ) && $page['includes']  ) {

       // Create an $sxml object but only if it isn;t created/
       if ( ! isset($sxml) ) {
           // Name of our Sources file
           $sfile = 'page_'.strtolower($page['name']).'.xml';
           $sxml = new NoAhRdfModel();
           $sxml->setName($sfile);
       }

       $muri = '../ns/includes/'.$page['name'];
       $sxml->addStatement($muri,'RDF:type','RDF:Seq');

       foreach( $page['includes'] as $i=>$data ){
           $uri = '../ns/include/'.$data['name'];
           $sxml->addStatement($muri,'RDF:li',$uri);
           error_log("Adding $uri to $muri");
           foreach( $data as $key=>$value) {
               error_log("Adding $key == $value to $uri");
              $sxml->addStatement($uri,'noah:'.$key,$value);
           }
       }
       $save_source = true;
       unset($muri);
   }


   // IF we have updated or created a source model then backup
   // and save the source xml
   if ( $save_source ) {
     //print_r($page['sources']);
     $backedup = false;
     if ( $sxml->hasFile() ) {
        if ( ! $sxml->backupModel( $sfile.'.bak' ) ){
           $err = "\nFailed to backup ".$sfile.", changes aborted on this file.";
           }else{
              $backedup = true;
           }
       }
       // Save our model to a file
       if ( isset($err) ) {
         $results .= $err;
       }else{
         $saved = $sxml->saveModel();
         if ( $saved ) {
          $results .= "\nSaved page content sources.";
         } else {
          $results .= "\nFailed to save page content sources";
         }
       }       
       if ( $backedup ) {
        $results .= "\nA Backup of the existing ".$page['package']." file was created.";
       }
   }// END 
       
   // DELETE LEFT OVER SOURCE XML FILE IF FOUND
   // If there is a source file for this page but there are no 
   // actual sources or includes then we  no longer need that file
   // and should delete it.
   if ( ! $save_source ) {
       if ( is_file(XML_PATH.'/page_'.strtolower($page['name']).'.xml') ) {
           unlink( XML_PATH.'/page_'.strtolower($page['name']).'.xml' );
       }
   }



   // IF results were saved update our web pages content list
   if ( $saved ) {
       require_once(CORE_PATH.'/class/noahlib/NoAhContentList.php');
       $plist = new NoAhContentList('noah_pages');
       $pname = str_replace('pkg_','',$page['package']);
       $pname = str_replace('.xml','',$pname);
       $plist->addValue($page['label'], $page['mod'].'/'.$pname.'/'.$page['name'] );
       $plist->saveListXML();
   }

   // If saved and our page is a theme. save to noah theme list
   if ( $saved && $page['is_theme'] ) {
       require_once(CORE_PATH.'/class/noahlib/NoAhContentList.php');
       $plist = new NoAhContentList('noah_themes');
       $pname = str_replace('pkg_','',$page['package']);
       $pname = str_replace('.xml','',$pname);
       $plist->addValue($page['label'], $page['mod'].'/'.$pname.'/'.$page['name'] );
       //$plist->saveListXML();
   }


   // Return results.
   $noAh->addContent('results', $results );


   //*/
   
   //$prd = "RDF:type";
   //$obj = "noah:cmd";
   //$pid = $pkgxml->isStatement( $sub, $prd );
   
   //print_r($org_pkg[$pid]);
   
   
?>
