<?php
/**
 * NoAh Installer goes through the process of installing
 * and configuring NoAh to run for the first time.
 * 
 * At the end of this process the User should have a functioning
 * default NoAh configuration and web site.
 *
 * Start the process by setting the current stage of the install
 * and attempt to run that stage. Each stage checks it's own
 * authorization setup.
 */
 if ( ! defined('CORE_PATH') ) {
     trigger_error(" Failed attempt modify conf file", E_USER_ERROR );
 }
 
 if ( isset($_POST['conf_token']) && isset($_SESSION['conf_token']) && $_POST['conf_token']==$_SESSION['conf_token'] ) {
 
     // clear our token 
     unset($_SESSION['conf_token']);

     // Open noah_conf file for writing.
     if ( is_file( $nUpdate->site_path.'/noah_conf.php') ) {
         if ( is_writable($nUpdate->site_path.'/noah_conf.php') ){

           if (!$handle = fopen($nUpdate->site_path.'/noah_conf.php', 'w')) {
                 trigger_error( "Failed to open configuration file", E_USER_ERROR );
           }
        
           ob_start();
           include( $nUpdate->core_path .'/modules/noupdate/templates/noah_conf_template.php' );
           $somecontent = ob_get_contents();
           ob_end_clean();

           // Write $somecontent to our opened file.
           if (fwrite($handle, $somecontent) === FALSE) {
               trigger_error( "Failed to write to configuration file", E_USER_ERROR );
           }
          
           fclose($handle);

         } else {
             trigger_error("Permission denied cannot modify configuration file", E_USER_ERROR );
         }
     } else {
         trigger_error("Failed to find configuration file", E_USER_ERROR );
     }

     // write template to noah_conf and save
     
     // redirect back to stage 1 where noah_conf should be validated.
     $nUpdate->passStage(2);
     header('Location: '.$self.'?stage=3');

 }
?>
