<?php

   // This stage is only applicable if we are setting up something
   // new. If we are not setting up something new, skip this step
   if ( $nUpdate->is_new ) {

    // Accept post details for conf file settings.
    // This uses a token, which is also generated by this page.
    if ( isset($_POST['conf_token']) && isset($_SESSION['conf_token']) && $_POST['conf_token']==$_SESSION['conf_token'] ) {
        // print_r($_POST);

        // validate _POST
        $error = array();
        if ( isset($_POST['site_url']) && $_POST['site_url'] && $_POST['site_url'] != 'http://'  ) {
            // Add verbose validation here.
        }else{
            $error['site_url'] = "You must provide a complete URL for your site.";
        }
        if ( isset($_POST['site_path']) && $_POST['site_path']  ) {
            // Add verbose validation here.
        }else{
            $error['site_path'] = "You must provide a valid path to your web site root.";
        }
        if ( isset($_POST['core_path'])  && $_POST['core_path'] ) {
            // Add verbose validation here.
        }else{
            $error['core_path'] = "You must provide a valid path to your main noah folder.";
        }
        if ( isset($_POST['xml_path'])  && $_POST['xml_path'] ) {
            // Add verbose validation here.
        }else{
            $error['site_url'] = "You must provide a valid path to your noah xml folder.";
        }
        if ( isset($_POST['upload_path'])  && $_POST['upload_path'] ) {
            // Add verbose validation here.
        }else{
            $error['site_url'] = "You must provide a valid path to your uploads directory.";
        }

        $test_db_conn = true;
        if ( isset($_POST['default_host'])  && $_POST['default_host'] ) {
            // Add verbose validation here.
        }else{
            $error['default_host'] = "You must provide a correct database host name.";
            $test_db_conn = false;
        }
        if ( isset($_POST['default_user'])  && $_POST['default_user'] ) {
            // Add verbose validation here.
        }else{
            $error['default_user'] = "You must provide a username for your database.";
            $test_db_conn = false;
        }
        if ( isset($_POST['default_pass'])  && $_POST['default_pass'] ) {
            // Add verbose validation here.
        }else{
            $error['default_pass'] = "You must provide a password for your database.";
            $test_db_conn = false;
        }
        if ( isset($_POST['default_database'])  && $_POST['default_database'] ) {
            // Add verbose validation here.
        }else{
            $error['default_database'] = "You must provide a name for your database.";
            $test_db_conn = false;
        }

        // TEST the Database connection to make sure it works.
        if ( $test_db_conn ) {
            $dbtest = new NoAhDatabase();
            $host = $_POST['default_host'];
            if ( isset($_POST['default_port'])) { $host .= ':'.$_POST['default_port']; }
            $user = $_POST['default_user'];
            $password = $_POST['default_pass'];
            $database = $_POST['default_database'];
            $res = @$dbtest->testConnection( $host, $user, $password, $database);
            if ( $res !== true  ) {
                $error['db_conn'] = $res;
            }
        }
        
        foreach($_POST as $ii=>$v)
        {
            $nUpdate->$ii = $v;
        }

        if ( ! $error ) {
            include(CORE_PATH.'/modules/noupdate/scripts/build_conf_file.php');
        }

        // kill session token
        unset($_SESSION['conf_token']);

    }

    // Set Up NoAh COnf Values
    include_once( $nUpdate->core_path.'/class/noahlib/NoAhFormBuilder.php' );

    $myConf = new NoAhFormBuilder('myconf');
    $site_url = ( $nUpdate->site_url ) ? $nUpdate->site_url : 'http://' ;
    $myConf->addFormField('site_url','Site URL','text', $site_url );
    $tip = 'The URL for your NoAh web site';
    if ( isset($error['site_url']) ) { $tip .= '<br/><span style="color:red">'.$error['site_url'].'</span>';}
    $myConf->setProperty('site_url','helptip', $tip);

    $myConf->addFormField('site_path','Site Path','text',$nUpdate->site_path);
    $tip = 'The full path to your root web site folder';
    if ( isset($error['site_path']) ) { $tip .= '<br/><span style="color:red">'.$error['site_path'].'</span>';}
    $myConf->setProperty('site_path','helptip', $tip);

    $myConf->addFormField('core_path','Core Path','text',$nUpdate->core_path);
    $tip = 'The full path to main \'noah\' folder';
    if ( isset($error['core_path']) ) { $tip .= '<br/><span style="color:red">'.$error['site_url'].'</span>';}
    $myConf->setProperty('core_path','helptip', $tip);

    $myConf->addFormField('xml_path','XML Path','text',$nUpdate->xml_path );
    $tip = 'The full path to your \'xml\' folder';
    if ( isset($error['xml_path']) ) { $tip .= '<br/><span style="color:red">'.$error['xml_path'].'</span>';}
    $myConf->setProperty('xml_path','helptip', $tip);

    $myConf->addFormField('upload_path','Uploads Path','text',$nUpdate->upload_path );
    $tip = 'The full path to your \'uploads\' folder';
    if ( isset($error['upload_path']) ) { $tip .= '<br/><span style="color:red">'.$error['upload_path'].'</span>';}
    $myConf->setProperty('upload_path','helptip', $tip);

    $default_host = ($nUpdate->default_host)?$nUpdate->default_host:'localhost';
    $myConf->addFormField('default_host','Database Server','text',$default_host);
    $tip = 'The server where your main database is located';
    if ( isset($error['default_host']) ) { $tip .= '<br/><span style="color:red">'.$error['default_host'].'</span>';}
    $myConf->setProperty('default_host','helptip', $tip);

    $myConf->addFormField('default_port','Database Port','text',$nUpdate->default_port);
    $tip = 'MySQL port for your default host * optional';
    if ( isset($error['default_port']) ) { $tip .= '<br/><span style="color:red">'.$error['default_port'].'</span>';}
    $myConf->setProperty('default_port','helptip', $tip);

    $myConf->addFormField('default_user','Username','text',$nUpdate->default_user);
    $tip = 'Username used to access your default database';
    if ( isset($error['default_user']) ) { $tip .= '<br/><span style="color:red">'.$error['default_user'].'</span>';}
    $myConf->setProperty('default_user','helptip', $tip);

    $myConf->addFormField('default_pass','Password','text',$nUpdate->default_pass);
    $tip = 'Password used to access your default database';
    if ( isset($error['default_pass']) ) { $tip .= '<br/><span style="color:red">'.$error['default_pass'].'</span>';}
    $myConf->setProperty('default_pass','helptip', $tip);

    $myConf->addFormField('default_database','Database Name','text',$nUpdate->default_database);
    $tip = 'Name of your default database';
    if ( isset($error['default_database']) ) { $tip .= '<br/><span style="color:red">'.$error['default_database'].'</span>';}
    $myConf->setProperty('default_database','helptip', $tip);

    // Create a token
    $_SESSION['conf_token'] = md5(rand(10000,99999).'_'.time());
    $myConf->addFormField('conf_token','','hidden',$_SESSION['conf_token']);

    $fields = $myConf->renderFields();

    include( CORE_PATH.'/modules/noupdate/templates/setup_noahconf.php' );
    $nUpdate->saveMemory();

   } else {
     $nUpdate->passStage(2);
     $nUpdate->saveMemory();
     $stage = 3;
   }
?>
