<?php
 
 // define our filenames
 $sources_xml = 'list_noah_sources.xml';
 $lists_xml = 'list_noah_lists.xml';
 
 // Include our NoAhContentList Class
 require_once(CORE_PATH.'/class/noahlib/NoAhContentList.php');

 // Create a NoAhContent List class onbject for each noah_ list we want to
 // create. 
 $cs_xml = new NoAhContentList('fakename');
 $cs_xml->setAttribute('name', $sources_xml );
 $cl_xml = new NoAhContentList('fakename');
 $cl_xml->setAttribute('name', $lists_xml );

 // Find all modules
 // Look for all module folders
 
  $core_files = listContents( CORE_PATH.'/xml/' );
  $user_files = listContents( XML_PATH.'/' );
 
  // Combine both core and user file arrays, but make sure
  // that values from 'users' takes precident over values
  // in core files.
  foreach( $core_files as $i=>$file ) {
      if ( is_file( CORE_PATH.'/xml/'.$file)  
           && ! in_array($file,$user_files) ) {
          $myfiles[] = $file;
      }
  }
  foreach( $user_files as $i=>$file ) {
      if ( is_file( XML_PATH.'/'.$file) ) {
          $myfiles[] = $file;
      }
  }

  print "-- Processing ".count($myfiles)." Files <br/>";

  // Loop over $myfiles and file source and list xml files
  foreach( $myfiles as $i=>$filename ) {

      // Look for sources
      if ( $sfile = strstr($filename,'source_') ) {
          $sources[] = $sfile;
      }
      // Look for Lists
      if ( $lfile = strstr($filename,'list_') ) {
          $lists[] = $lfile;
      }

  }

  print "--- Found ".count($sources)." Content Sources<br/>";
  print "--- Found ".count($lists)." Content Lists<br/>";

  // 
  require_once( CORE_PATH.'/class/noahlib/NoAhContentSource.php' );

  foreach( $sources as $i=>$source )
  {
       $nsource = new NoAhContentSource( $source );
       $nsource->loadSourceFile();
       $sd = $nsource->sourceDetails();

       // Add Source Details so Noah Sources List
       $cs_xml->addValue($sd['label'],$sd['name'],$sd['desc'],99);

       unset($nsource);
       unset($sd);
  }

  require_once( CORE_PATH.'/class/noahlib/NoAhContentList.php' );

  foreach( $lists as $i=>$list )
  {
      $nlist = new NoAhContentList( $list );
      $ld = $nlist->getListDetails();

      $cl_xml->addValue($ld['label'],$ld['name'],$ld['desc'],99);
      unset($nlist);
      unset($ld);

  }

 // print '<pre>';
 // print_r($tmp);
 // print '<pre>';
 // die();
  $res = $cs_xml->saveListXML();
  print "-> Saving list of content sources : $res <br/>";
  $res = $cl_xml->saveListXML();
  print "-> Saving list of content lists : $res <br/>";

 

 
?>