<?php
// $Id: mypages_index.php,v 1.1 2005/03/13 07:25:38 kerkness Exp $

   /**
    * This file is part of NoAh.
    * 
    * NoAh is free software; you can redistribute it and/or modify
    * it under the terms of the GNU General Public License as published by
    * the Free Software Foundation; either version 2 of the License, or
    * (at your option) any later version.
    * 
    * NoAh is distributed in the hope that it will be useful,
    * but WITHOUT ANY WARRANTY; without even the implied warranty of
    * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    * GNU General Public License for more details.
    * 
    * You should have received a copy of the GNU General Public License
    * along with NoAh; if not, write to the Free Software
    * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    */
    
    require_once( CORE_PATH.'/class/noahlib/NoAhContentReader.php');
    require_once( CORE_PATH.'/class/noahlib/NoAhContentWriter.php');
    
    // Handle submission of the user registration form.
    $posterr = array();
    if ( $_POST ) {
        // Create an instance of the NoAh Content Reader
        $myReader = new NoAhContentReader('nousers');

        //Check for exsisting users by submitted user name;
        $myReader->addFilter('username','=',$_POST['username']);
        if ( $myReader->countContent() ) {
            $posterr['username'] = "Username invalid or already in use.";
        }
        $myReader->clearFilter();
        $myReader->addFilter('email','=',$_POST['email']);
        if ( $myReader->countContent() ) {
            $posterr['email'] = "Email is already in use.";
        }

        if ( ! $posterr ) { // START ACTUAL REGISTRATION
            $myWriter = new NoAhContentWriter('nousers');

            $myWriter->addField('username', $_POST['username']);
            $myWriter->addField('email', $_POST['email']);
            $myWriter->addField('password', md5($_POST['password']));

            if ( ! $myWriter->insert() ) {
                trigger_error( $myWriter->conn->error()."\n".$myWriter->conn->sql, E_USER_ERROR );
            }

            // Include the script  nouser_login  which will 
            // handle this same _POST as a request for authentication
            include( CORE_PATH.'/modules/nousers/scripts/nouser_login.php' );

        } // END REGISTERING USER

    }
   
    require_once(CORE_PATH.'/class/noahlib/NoAhFormBuilder.php');
    
    $registerForm = new NoAhFormBuilder('registerform','html');    

    $registerForm->setAttribute('action', 'request.php');    
    $registerForm->setAttribute('method', 'post');       

    $registerForm->addFormField( 'mod', '', 'hidden', 'nousers');
    $registerForm->addFormField( 'pkg', '', 'hidden', 'authorization');
    $registerForm->addFormField( 'cmd', '', 'hidden', 'registerUser');

    $registerForm->addFormField('username',_USERNAME,'text','');
    $registerForm->addFormField('email',_USER_EMAIL,'text','');
    $registerForm->addFormField('password',_USER_PASSWORD,'password','');
    $registerForm->addFormField('conf_password',_USER_CONFIRM_PASSWORD,'password','');
    $registerForm->addFormField('submit_registration','','button',_REGISTER_BUTTON);
    $registerForm->setProperty('submit_registration','extra',' onclick="checkNoUserRegistration()"');
    
    $noAh->addContent('rform', $registerForm->renderForm() );
    // $noAh->changeTemplate(0,'nouser_loginform_xul.php');
    $noAh->addContent('posterr' , $posterr );
    
     
?>
